"use strict";

var _excluded = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded2 = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded3 = ["error", "success", "header", "footer", "includeTel", "includeLabels", "repeatValidation", "fieldOverrides"],
    _excluded4 = ["input", "name"],
    _excluded5 = ["error", "success", "header", "footer", "includeTel", "repeatValidation", "fieldOverrides"],
    _excluded6 = ["input", "name"],
    _excluded7 = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded8 = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded9 = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded10 = ["error", "success", "header", "footer", "fieldOverrides"],
    _excluded11 = ["title", "className", "isOpen"];

function _wrapRegExp() { _wrapRegExp = function _wrapRegExp(re, groups) { return new BabelRegExp(re, undefined, groups); }; var _super = RegExp.prototype; var _groups = new WeakMap(); function BabelRegExp(re, flags, groups) { var _this = new RegExp(re, flags); _groups.set(_this, groups || _groups.get(re)); return _setPrototypeOf(_this, BabelRegExp.prototype); } _inherits(BabelRegExp, RegExp); BabelRegExp.prototype.exec = function (str) { var result = _super.exec.call(this, str); if (result) result.groups = buildGroups(result, this); return result; }; BabelRegExp.prototype[Symbol.replace] = function (str, substitution) { if (typeof substitution === "string") { var groups = _groups.get(this); return _super[Symbol.replace].call(this, str, substitution.replace(/\$<([^>]+)>/g, function (_, name) { return "$" + groups[name]; })); } else if (typeof substitution === "function") { var _this = this; return _super[Symbol.replace].call(this, str, function () { var args = arguments; if (_typeof(args[args.length - 1]) !== "object") { args = [].slice.call(args); args.push(buildGroups(args, _this)); } return substitution.apply(this, args); }); } else { return _super[Symbol.replace].call(this, str, substitution); } }; function buildGroups(result, re) { var g = _groups.get(re); return Object.keys(g).reduce(function (groups, name) { groups[name] = result[g[name]]; return groups; }, Object.create(null)); } return _wrapRegExp.apply(this, arguments); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e2) { throw _e2; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e3) { didErr = true; err = _e3; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var BooyaTranslations = /*#__PURE__*/function () {
  function BooyaTranslations() {
    var _this$phrases$ACCOUNT, _this$phrases$ACCOUNT2, _this$phrases$ACCOUNT3, _this$phrases$ACCOUNT4, _this$phrases$ACCOUNT5, _this$phrases$ALREADY, _this$phrases$BACK_TO, _this$phrases$COMPLET, _this$phrases$CONFIRM, _this$phrases$DONT_HA, _this$phrases$EDIT_PR, _this$phrases$EMAIL, _this$phrases$EMAIL_V, _this$phrases$FIRST_N, _this$phrases$FORGOT_, _this$phrases$LAST_NA, _this$phrases$LOADING, _this$phrases$NEXT, _this$phrases$NEW_PAS, _this$phrases$OOPS_SO, _this$phrases$OOPS_CH, _this$phrases$OOPS_FI, _this$phrases$OOPS_FI2, _this$phrases$OOPS_AC, _this$phrases$OOPS_SA, _this$phrases$OOPS_SE, _this$phrases$OOPS_SI, _this$phrases$OOPS_RE, _this$phrases$OPTIONA, _this$phrases$OR, _this$phrases$PASSWOR, _this$phrases$PASSWOR2, _this$phrases$PLEASE_, _this$phrases$PASSWOR3, _this$phrases$PASSWOR4, _this$phrases$PASSWOR5, _this$phrases$PASSWOR6, _this$phrases$PASSWOR7, _this$phrases$PASSWOR8, _this$phrases$PASSWOR9, _this$phrases$PASSWOR10, _this$phrases$PHONE_N, _this$phrases$PLEASE_2, _this$phrases$PLEASE_3, _this$phrases$PLEASE_4, _this$phrases$PLEASE_5, _this$phrases$PLEASE_6, _this$phrases$PROFILE, _this$phrases$RECOVER, _this$phrases$REGISTE, _this$phrases$REQUEST, _this$phrases$REQUEST2, _this$phrases$RESENDI, _this$phrases$RESET_P, _this$phrases$SAVE, _this$phrases$SELECT, _this$phrases$SEND_MA, _this$phrases$SET_PAS, _this$phrases$SIGN_IN, _this$phrases$SIGN_IN2, _this$phrases$SIGN_IN3, _this$phrases$SIGN_IN4, _this$phrases$SIGN_IN5, _this$phrases$SIGN_IN6, _this$phrases$SIGN_IN7, _this$phrases$SIGN_OU, _this$phrases$SIGN_UP, _this$phrases$SIGN_UP2, _this$phrases$SIGN_UP3, _this$phrases$SIGNED_, _this$phrases$SORRY_C, _this$phrases$TELEPHO, _this$phrases$THIS_MO, _this$phrases$THIS_MO2, _this$phrases$THIS_MO3, _this$phrases$THIS_MO4, _this$phrases$THIS_LI, _this$phrases$THIS_LI2, _this$phrases$THIS_MA, _this$phrases$VERIFYI, _this$phrases$YOUR_EM, _defineProperty2;

    _classCallCheck(this, BooyaTranslations);

    _defineProperty(this, "languages", {
      ENGLISH: 'en',
      SPANISH: 'es',
      FRENCH: 'fr'
    });

    _defineProperty(this, "phrases", {
      ACCOUNT_CREATED_CHECK_INBOX: '🎉 Account created successfully! Please check your inbox for instructions.',
      ACCOUNT_EXISTS: '❌ An account with this email already exists.',
      ACCOUNT_VERIFICATION_SENT: '🎉 A verification email has been sent to {email}. Please check your inbox for instructions.',
      ACCOUNT_RECOVERY: 'Account Recovery',
      ACCOUNT_VERIFICATION_COMPLETE: '🎉 Account verification complete.',
      ALREADY_HAVE_ACCOUNT: 'Already have an account?',
      BACK_TO_SIGN_IN: 'Back to Sign In',
      COMPLETE_PROFILE: 'Complete Profile',
      CONFIRM_PASSWORD: 'Confirm Password',
      DONT_HAVE_ACCOUNT: "Don't have an account?",
      EDIT_PROFILE: 'Edit Profile',
      EMAIL: 'Email',
      EMAIL_VERIFIED_SUCCESSFULLY: '🎉 Email verified successfully!',
      FIRST_NAME: 'First Name',
      FORGOT_PASSWORD: 'Forgot password?',
      LAST_NAME: 'Last Name',
      LOADING: 'Loading ...',
      NEXT: 'Next',
      NEW_PASSWORD: 'New Password',
      OOPS_SOMETHING_WRONG: '❌ Oops, something went wrong, Please try again.',
      OOPS_SOMETHING_WRONG_SUPPORT: '❌ Oops, something went wrong, Please contact support for assistance.',
      OOPS_CHANGE_PASSWORD: "❌ Oops, we couldn't change your password, Please try again.",
      OOPS_FIND_ACCOUNT_EMAIL_PASSWORD: "❌ Oops, we couldn't find an account with that email and password, Please try again.",
      OOPS_FIND_ACCOUNT_EMAIL: "❌ Oops, we couldn't find an account with that email, Please try again.",
      OOPS_ACCOUNT_RECOVERY: "❌ Oops, we couldn't initiate account recovery, Please try again.",
      OOPS_ACCOUNT_RECOVERY_SUPPORT: "❌ Oops, we couldn't initiate account recovery, Please contact support for assistance.",
      OOPS_SAVE_PROFILE: "❌ Oops, we couldn't save your profile, Please try again.",
      OOPS_SET_PASSWORD: "❌ Oops, we couldn't set your password, Please try again.",
      OOPS_SIGN_IN: "❌ Oops, we couldn't sign you in, Please try again.",
      OOPS_SIGN_IN_SUPPORT: "❌ Oops, we couldn't sign you in, Please contact support for assistance.",
      OOPS_RESEND_MAGIC_LINK: "❌ Oops, we couldn't resend a magic link to your email, Please try again.",
      OPTIONAL: 'optional',
      OR: 'OR',
      PASSWORD: 'Password',
      PASSWORD_CANT_CONTAIN_WORD: 'Password cannot contain {word}',
      PLEASE_CHECK_INBOX_INSTRUCTIONS: '🎉 Please check your email inbox for instructions.',
      PASSWORD_AT_LEAST_CHARACTERS: 'Password must be at least {number} characters long.',
      PASSWORD_AT_LEAST_CHARACTER: 'Password must be at least {number} character long.',
      PASSWORD_MUST_CONTAIN_DIGIT: 'Password must contain at least one digit',
      PASSWORD_MUST_CONTAIN_LOWERCASE_LETTER: 'Password must contain at least one lowercase letter',
      PASSWORD_MUST_CONTAIN_UPPERCASE_LETTER: 'Password must contain at least one uppercase letter',
      PASSWORD_MUST_CONTAIN_SPECIAL_CHARACTERS: 'Password must contain at least one special character e.g @,!,&',
      PASSWORD_SET_SUCCESSFULLY: '🎉 Password set successfully! You can now sign into your account.',
      PASSWORD_UPDATED_SUCCESSFULLY: '🎉 Password updated successfully!',
      PHONE_NUMBER: 'Phone number',
      PLEASE_COMPLETE_FIELD: 'Please complete this required field.',
      PLEASE_FIX_ERRORS: '❌ Please fix the errors in the form and try again!',
      PLEASE_ENTER_VALID_EMAIL: 'Please enter a valid email.',
      PLEASE_ENTER_VALID_URL: 'Please enter a valid URL',
      PLEASE_VERIFY_EMAIL: '❌ Please verify your email.<br/> Check your email inbox for instructions.',
      PROFILE_UPDATED_SUCCESSFULLY: '🎉 Profile updated successfully!',
      RECOVER: 'Recover',
      REGISTER: 'Register',
      REQUEST_INVITE: 'Request an invite',
      REQUEST_NEW_MAGIC_LINK: 'Request new magic link',
      RESENDING_MAGIC_LINK: 'Resending a new magic link ...',
      RESET_PASSWORD: 'Reset Password',
      SAVE: 'Save',
      SELECT: 'Select',
      SEND_MAGIC_LINK: 'Send magic link',
      SET_PASSWORD: 'Set Password',
      SIGN_IN: 'Sign in',
      SIGN_IN_TITLE: 'Sign In',
      SIGN_IN_OR_REGISTER: 'Sign In or Register',
      SIGN_IN_WITH: 'Sign in with',
      SIGN_IN_WITH_MAGIC_LINK: 'Sign in with a magic link',
      SIGN_IN_WITH_PROVIDER: 'Sign in with {provider}',
      SIGN_IN_WITH_USERNAME_AND_PASSWORD: 'Sign in with email and password',
      SIGN_OUT: 'Sign Out',
      SIGN_UP: 'Sign up',
      SIGN_UP_WITH: 'Sign up with',
      SIGN_UP_WITH_PROVIDER: 'Sign up with {provider}',
      SIGNED_IN_SUCCESSFULLY: '🎉 Signed in successfully!',
      SORRY_CANT_SIGN_UP: "❌ Sorry, we can't sign you up with email and password at this time.",
      SORRY_CANT_SIGN_UP_SUPPORT: "❌ Sorry, we can't sign you up with email and password at this time. Please contact support for assistance.",
      TELEPHONE: 'Telephone',
      THIS_MORE_CHARACTERS: 'This is more than {number} characters',
      THIS_MORE_CHARACTER: 'This is more than {number} character',
      THIS_MORE_WORDS: 'This is more than {number} words',
      THIS_MORE_WORD: 'This is more than {number} word',
      THIS_LINK_IS_INVALID_EXPIRED_SUPPORT: '❌ This link is either invalid or has expired.<br/> Please contact support for a new link.',
      THIS_LINK_IS_INVALID_EXPIRED_GENERATE: '❌ This link is either invalid or has expired.<br/> Please generate a new recovery link {link_open}here{link_close}.',
      THIS_MAGIC_LINK_INVALID_EXPIRED: '❌ This magic link is either invalid or has expired.',
      VERIFYING: 'Verifying ...',
      YOUR_EMAIL_NOT_VERIFIED_CHECK_INBOX: 'Your email address ({email}) is not verified. Please check your inbox for instructions or {link_open}click here{link_close} to resend the verification email.'
    });

    _defineProperty(this, "translations", (_defineProperty2 = {}, _defineProperty(_defineProperty2, this.phrases.ACCOUNT_CREATED_CHECK_INBOX, (_this$phrases$ACCOUNT = {}, _defineProperty(_this$phrases$ACCOUNT, this.languages.SPANISH, '🎉 ¡La cuenta ha sido creada exitosamente! Por favor, diríjase a su inbox y siga las instrucciones en el mail que le hemos enviado.'), _defineProperty(_this$phrases$ACCOUNT, this.languages.FRENCH, '🎉 Le compte a été créé avec succès ! Consultez votre boîte de réception pour obtenir des instructions.'), _this$phrases$ACCOUNT)), _defineProperty(_defineProperty2, this.phrases.ACCOUNT_EXISTS, (_this$phrases$ACCOUNT2 = {}, _defineProperty(_this$phrases$ACCOUNT2, this.languages.SPANISH, '❌ Ya existe una cuenta con este correo.'), _defineProperty(_this$phrases$ACCOUNT2, this.languages.FRENCH, '❌ Un compte avec cette adresse e-mail existe déjà.'), _this$phrases$ACCOUNT2)), _defineProperty(_defineProperty2, this.phrases.ACCOUNT_VERIFICATION_SENT, (_this$phrases$ACCOUNT3 = {}, _defineProperty(_this$phrases$ACCOUNT3, this.languages.SPANISH, '🎉 Se le ha enviado un correo de verificación a {email} con las instrucciones.'), _defineProperty(_this$phrases$ACCOUNT3, this.languages.FRENCH, '🎉 Un e-mail de vérification a été envoyé à {email}. Consultez votre boîte de réception pour obtenir des instructions.'), _this$phrases$ACCOUNT3)), _defineProperty(_defineProperty2, this.phrases.ACCOUNT_RECOVERY, (_this$phrases$ACCOUNT4 = {}, _defineProperty(_this$phrases$ACCOUNT4, this.languages.SPANISH, 'Recuperación de cuenta'), _defineProperty(_this$phrases$ACCOUNT4, this.languages.FRENCH, 'Récupération du compte'), _this$phrases$ACCOUNT4)), _defineProperty(_defineProperty2, this.phrases.ACCOUNT_VERIFICATION_COMPLETE, (_this$phrases$ACCOUNT5 = {}, _defineProperty(_this$phrases$ACCOUNT5, this.languages.SPANISH, '🎉 La confirmación de cuenta ha sido completada.'), _defineProperty(_this$phrases$ACCOUNT5, this.languages.FRENCH, '🎉 La vérification du compte est terminée.'), _this$phrases$ACCOUNT5)), _defineProperty(_defineProperty2, this.phrases.ALREADY_HAVE_ACCOUNT, (_this$phrases$ALREADY = {}, _defineProperty(_this$phrases$ALREADY, this.languages.SPANISH, '¿Ya dispone de una cuenta?'), _defineProperty(_this$phrases$ALREADY, this.languages.FRENCH, 'Vous avez déjà un compte?'), _this$phrases$ALREADY)), _defineProperty(_defineProperty2, this.phrases.BACK_TO_SIGN_IN, (_this$phrases$BACK_TO = {}, _defineProperty(_this$phrases$BACK_TO, this.languages.SPANISH, 'Regresar para iniciar el registro.'), _defineProperty(_this$phrases$BACK_TO, this.languages.FRENCH, 'Retour pour se connecter.'), _this$phrases$BACK_TO)), _defineProperty(_defineProperty2, this.phrases.COMPLETE_PROFILE, (_this$phrases$COMPLET = {}, _defineProperty(_this$phrases$COMPLET, this.languages.SPANISH, 'Completar su perfil de cuenta.'), _defineProperty(_this$phrases$COMPLET, this.languages.FRENCH, 'Complètez votre profil.'), _this$phrases$COMPLET)), _defineProperty(_defineProperty2, this.phrases.CONFIRM_PASSWORD, (_this$phrases$CONFIRM = {}, _defineProperty(_this$phrases$CONFIRM, this.languages.SPANISH, 'Confirme su clave.'), _defineProperty(_this$phrases$CONFIRM, this.languages.FRENCH, 'Confirmez votre mot de passe.'), _this$phrases$CONFIRM)), _defineProperty(_defineProperty2, this.phrases.DONT_HAVE_ACCOUNT, (_this$phrases$DONT_HA = {}, _defineProperty(_this$phrases$DONT_HA, this.languages.SPANISH, '¿No dispone de una cuenta?'), _defineProperty(_this$phrases$DONT_HA, this.languages.FRENCH, 'Vous n\'avez pas de compte?'), _this$phrases$DONT_HA)), _defineProperty(_defineProperty2, this.phrases.EDIT_PROFILE, (_this$phrases$EDIT_PR = {}, _defineProperty(_this$phrases$EDIT_PR, this.languages.SPANISH, 'Editar perfil'), _defineProperty(_this$phrases$EDIT_PR, this.languages.FRENCH, 'Editer votre profil'), _this$phrases$EDIT_PR)), _defineProperty(_defineProperty2, this.phrases.EMAIL, (_this$phrases$EMAIL = {}, _defineProperty(_this$phrases$EMAIL, this.languages.SPANISH, 'Correo'), _defineProperty(_this$phrases$EMAIL, this.languages.FRENCH, 'E-mail'), _this$phrases$EMAIL)), _defineProperty(_defineProperty2, this.phrases.EMAIL_VERIFIED_SUCCESSFULLY, (_this$phrases$EMAIL_V = {}, _defineProperty(_this$phrases$EMAIL_V, this.languages.SPANISH, '🎉 ¡El correo ha sido verificado de manera correcta!'), _defineProperty(_this$phrases$EMAIL_V, this.languages.FRENCH, '🎉 E-mail vérifié avec succès!'), _this$phrases$EMAIL_V)), _defineProperty(_defineProperty2, this.phrases.FIRST_NAME, (_this$phrases$FIRST_N = {}, _defineProperty(_this$phrases$FIRST_N, this.languages.SPANISH, 'Nombre'), _defineProperty(_this$phrases$FIRST_N, this.languages.FRENCH, 'Prénom'), _this$phrases$FIRST_N)), _defineProperty(_defineProperty2, this.phrases.FORGOT_PASSWORD, (_this$phrases$FORGOT_ = {}, _defineProperty(_this$phrases$FORGOT_, this.languages.SPANISH, '¿Ha olvidado su contraseña?'), _defineProperty(_this$phrases$FORGOT_, this.languages.FRENCH, 'Avez-vous oublié votre mot de passe?'), _this$phrases$FORGOT_)), _defineProperty(_defineProperty2, this.phrases.LAST_NAME, (_this$phrases$LAST_NA = {}, _defineProperty(_this$phrases$LAST_NA, this.languages.SPANISH, 'Apellido'), _defineProperty(_this$phrases$LAST_NA, this.languages.FRENCH, 'Nom de famille'), _this$phrases$LAST_NA)), _defineProperty(_defineProperty2, this.phrases.LOADING, (_this$phrases$LOADING = {}, _defineProperty(_this$phrases$LOADING, this.languages.SPANISH, 'Cargando ...'), _defineProperty(_this$phrases$LOADING, this.languages.FRENCH, 'Chargement ...'), _this$phrases$LOADING)), _defineProperty(_defineProperty2, this.phrases.NEXT, (_this$phrases$NEXT = {}, _defineProperty(_this$phrases$NEXT, this.languages.SPANISH, 'Siguiente'), _defineProperty(_this$phrases$NEXT, this.languages.FRENCH, 'Prochain'), _this$phrases$NEXT)), _defineProperty(_defineProperty2, this.phrases.NEW_PASSWORD, (_this$phrases$NEW_PAS = {}, _defineProperty(_this$phrases$NEW_PAS, this.languages.SPANISH, 'Nueva clave'), _defineProperty(_this$phrases$NEW_PAS, this.languages.FRENCH, 'Nouveau mot de passe'), _this$phrases$NEW_PAS)), _defineProperty(_defineProperty2, this.phrases.OOPS_SOMETHING_WRONG, (_this$phrases$OOPS_SO = {}, _defineProperty(_this$phrases$OOPS_SO, this.languages.SPANISH, '❌ Algo salió mal. Por favor inténtelo de nuevo.'), _defineProperty(_this$phrases$OOPS_SO, this.languages.FRENCH, '❌ Oups, une erreur s\'est produite. Veuillez réessayez.'), _this$phrases$OOPS_SO)), _defineProperty(_defineProperty2, this.phrases.OOPS_CHANGE_PASSWORD, (_this$phrases$OOPS_CH = {}, _defineProperty(_this$phrases$OOPS_CH, this.languages.SPANISH, '❌ No pudimos cambiar su contraseña. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_CH, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu changer votre mot de passe.  Veuillez réessayer.'), _this$phrases$OOPS_CH)), _defineProperty(_defineProperty2, this.phrases.OOPS_FIND_ACCOUNT_EMAIL_PASSWORD, (_this$phrases$OOPS_FI = {}, _defineProperty(_this$phrases$OOPS_FI, this.languages.SPANISH, '❌ No pudimos encontrar ninguna cuenta con ese correo o clave. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_FI, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu trouver de compte avec cette adresse e-mail et ce mot de passe. Veuillez réessayer.'), _this$phrases$OOPS_FI)), _defineProperty(_defineProperty2, this.phrases.OOPS_FIND_ACCOUNT_EMAIL, (_this$phrases$OOPS_FI2 = {}, _defineProperty(_this$phrases$OOPS_FI2, this.languages.SPANISH, '❌ No pudimos encontrar ninguna cuenta con ese correo. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_FI2, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu trouver de compte avec cette adresse e-mail. Veuillez réessayer.'), _this$phrases$OOPS_FI2)), _defineProperty(_defineProperty2, this.phrases.OOPS_ACCOUNT_RECOVERY, (_this$phrases$OOPS_AC = {}, _defineProperty(_this$phrases$OOPS_AC, this.languages.SPANISH, '❌ No pudimos iniciar el proceso de recuperación de cuenta. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_AC, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu lancer la récupération du compte. Veuillez réessayer.'), _this$phrases$OOPS_AC)), _defineProperty(_defineProperty2, this.phrases.OOPS_SAVE_PROFILE, (_this$phrases$OOPS_SA = {}, _defineProperty(_this$phrases$OOPS_SA, this.languages.SPANISH, '❌ No pudimos guardar los cambios de su perfil. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_SA, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu enregistrer votre profil. Veuillez réessayer.'), _this$phrases$OOPS_SA)), _defineProperty(_defineProperty2, this.phrases.OOPS_SET_PASSWORD, (_this$phrases$OOPS_SE = {}, _defineProperty(_this$phrases$OOPS_SE, this.languages.SPANISH, '❌ No pudimos establecer su clave. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_SE, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu créer votre mot de passe. Veuillez réessayer.'), _this$phrases$OOPS_SE)), _defineProperty(_defineProperty2, this.phrases.OOPS_SIGN_IN, (_this$phrases$OOPS_SI = {}, _defineProperty(_this$phrases$OOPS_SI, this.languages.SPANISH, '❌ No pudimos completar el registro. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_SI, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu vous connecter. Veuillez réessayer.'), _this$phrases$OOPS_SI)), _defineProperty(_defineProperty2, this.phrases.OOPS_RESEND_MAGIC_LINK, (_this$phrases$OOPS_RE = {}, _defineProperty(_this$phrases$OOPS_RE, this.languages.SPANISH, '❌ Oops, No fue posible re-enviar el enlace magico a tu correo. Por favor intente de nuevo.'), _defineProperty(_this$phrases$OOPS_RE, this.languages.FRENCH, '❌ Oups, nous n\'avons pas pu renvoyer le lien magique a votre e-mail. Veuillez réessayer.'), _this$phrases$OOPS_RE)), _defineProperty(_defineProperty2, this.phrases.OPTIONAL, (_this$phrases$OPTIONA = {}, _defineProperty(_this$phrases$OPTIONA, this.languages.SPANISH, 'opcional'), _defineProperty(_this$phrases$OPTIONA, this.languages.FRENCH, 'optionnel'), _this$phrases$OPTIONA)), _defineProperty(_defineProperty2, this.phrases.OR, (_this$phrases$OR = {}, _defineProperty(_this$phrases$OR, this.languages.SPANISH, 'O'), _defineProperty(_this$phrases$OR, this.languages.FRENCH, 'OU'), _this$phrases$OR)), _defineProperty(_defineProperty2, this.phrases.PASSWORD, (_this$phrases$PASSWOR = {}, _defineProperty(_this$phrases$PASSWOR, this.languages.SPANISH, 'Clave'), _defineProperty(_this$phrases$PASSWOR, this.languages.FRENCH, 'Mot de passe'), _this$phrases$PASSWOR)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_CANT_CONTAIN_WORD, (_this$phrases$PASSWOR2 = {}, _defineProperty(_this$phrases$PASSWOR2, this.languages.SPANISH, 'La clave no puede contener {word}'), _defineProperty(_this$phrases$PASSWOR2, this.languages.FRENCH, 'Le mot de passe ne peut pas contenir {word}'), _this$phrases$PASSWOR2)), _defineProperty(_defineProperty2, this.phrases.PLEASE_CHECK_INBOX_INSTRUCTIONS, (_this$phrases$PLEASE_ = {}, _defineProperty(_this$phrases$PLEASE_, this.languages.SPANISH, '🎉 Por favor, diríjase a su inbox y siga las instrucciones en el mail que le hemos enviado.'), _defineProperty(_this$phrases$PLEASE_, this.languages.FRENCH, '🎉 Consultez votre boîte de réception pour obtenir des instructions.'), _this$phrases$PLEASE_)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_AT_LEAST_CHARACTERS, (_this$phrases$PASSWOR3 = {}, _defineProperty(_this$phrases$PASSWOR3, this.languages.SPANISH, 'La clave debe de tener al menos {number} caracteres de largo.'), _defineProperty(_this$phrases$PASSWOR3, this.languages.FRENCH, 'Le mot de passe doit comporter au moins {number} caractères.'), _this$phrases$PASSWOR3)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_AT_LEAST_CHARACTER, (_this$phrases$PASSWOR4 = {}, _defineProperty(_this$phrases$PASSWOR4, this.languages.SPANISH, 'La clave debe de tener al menos {number} caractere de largo.'), _defineProperty(_this$phrases$PASSWOR4, this.languages.FRENCH, 'Le mot de passe doit comporter au moins {number} caractère.'), _this$phrases$PASSWOR4)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_MUST_CONTAIN_DIGIT, (_this$phrases$PASSWOR5 = {}, _defineProperty(_this$phrases$PASSWOR5, this.languages.SPANISH, 'La clave debe de contener al menos un numero.'), _defineProperty(_this$phrases$PASSWOR5, this.languages.FRENCH, 'Le mot de passe doit contenir au moins un chiffre.'), _this$phrases$PASSWOR5)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_MUST_CONTAIN_LOWERCASE_LETTER, (_this$phrases$PASSWOR6 = {}, _defineProperty(_this$phrases$PASSWOR6, this.languages.SPANISH, 'La clave debe de contener al menos una carácter en minúsculas.'), _defineProperty(_this$phrases$PASSWOR6, this.languages.FRENCH, 'Le mot de passe doit contenir au moins une lettre minuscule.'), _this$phrases$PASSWOR6)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_MUST_CONTAIN_UPPERCASE_LETTER, (_this$phrases$PASSWOR7 = {}, _defineProperty(_this$phrases$PASSWOR7, this.languages.SPANISH, 'La clave debe de contener al menos una carácter en mayúsculas.'), _defineProperty(_this$phrases$PASSWOR7, this.languages.FRENCH, 'Le mot de passe doit contenir au moins une lettre majuscule.'), _this$phrases$PASSWOR7)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_MUST_CONTAIN_SPECIAL_CHARACTERS, (_this$phrases$PASSWOR8 = {}, _defineProperty(_this$phrases$PASSWOR8, this.languages.SPANISH, 'La clave debe al menos contener un carácter especial. Ejemplo: @, !, &.'), _defineProperty(_this$phrases$PASSWOR8, this.languages.FRENCH, 'Le mot de passe doit contenir au moins un caractère spécial, par exemple @,!,&'), _this$phrases$PASSWOR8)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_SET_SUCCESSFULLY, (_this$phrases$PASSWOR9 = {}, _defineProperty(_this$phrases$PASSWOR9, this.languages.SPANISH, '🎉 La clave o contraseña ha sido establecida. Ahora puede iniciar sesion con su cuenta.'), _defineProperty(_this$phrases$PASSWOR9, this.languages.FRENCH, '🎉 Mot de passe créé avec succès ! Vous pouvez vous connecter à votre compte.'), _this$phrases$PASSWOR9)), _defineProperty(_defineProperty2, this.phrases.PASSWORD_UPDATED_SUCCESSFULLY, (_this$phrases$PASSWOR10 = {}, _defineProperty(_this$phrases$PASSWOR10, this.languages.SPANISH, '🎉 ¡La clave o contraseña ha sido actualizada!'), _defineProperty(_this$phrases$PASSWOR10, this.languages.FRENCH, '🎉 Le mot de passe a été actualisé avec succès!'), _this$phrases$PASSWOR10)), _defineProperty(_defineProperty2, this.phrases.PHONE_NUMBER, (_this$phrases$PHONE_N = {}, _defineProperty(_this$phrases$PHONE_N, this.languages.SPANISH, 'Numero de teléfono'), _defineProperty(_this$phrases$PHONE_N, this.languages.FRENCH, 'Numéro de téléphone'), _this$phrases$PHONE_N)), _defineProperty(_defineProperty2, this.phrases.PLEASE_COMPLETE_FIELD, (_this$phrases$PLEASE_2 = {}, _defineProperty(_this$phrases$PLEASE_2, this.languages.SPANISH, 'Por favor complete este campo obligatorio.'), _defineProperty(_this$phrases$PLEASE_2, this.languages.FRENCH, 'Veuillez completer ce champ obligatoire.'), _this$phrases$PLEASE_2)), _defineProperty(_defineProperty2, this.phrases.PLEASE_FIX_ERRORS, (_this$phrases$PLEASE_3 = {}, _defineProperty(_this$phrases$PLEASE_3, this.languages.SPANISH, '❌ Por favor corrija los errores en el formulario e intente de nuevo.'), _defineProperty(_this$phrases$PLEASE_3, this.languages.FRENCH, '❌ Veuillez corriger les erreurs dans le formulaire et réessayer!'), _this$phrases$PLEASE_3)), _defineProperty(_defineProperty2, this.phrases.PLEASE_ENTER_VALID_EMAIL, (_this$phrases$PLEASE_4 = {}, _defineProperty(_this$phrases$PLEASE_4, this.languages.SPANISH, 'Por favor inserte un correo valido.'), _defineProperty(_this$phrases$PLEASE_4, this.languages.FRENCH, 'Veuillez entrer une adresse email valide.'), _this$phrases$PLEASE_4)), _defineProperty(_defineProperty2, this.phrases.PLEASE_ENTER_VALID_URL, (_this$phrases$PLEASE_5 = {}, _defineProperty(_this$phrases$PLEASE_5, this.languages.SPANISH, 'Por favor inserte una dirección URL valida.'), _defineProperty(_this$phrases$PLEASE_5, this.languages.FRENCH, 'Veuillez entrer une URL valide.'), _this$phrases$PLEASE_5)), _defineProperty(_defineProperty2, this.phrases.PLEASE_VERIFY_EMAIL, (_this$phrases$PLEASE_6 = {}, _defineProperty(_this$phrases$PLEASE_6, this.languages.SPANISH, '❌ Por favor verifique su correo electrónico.<br/> Revise su cuenta para las instrucciones.'), _defineProperty(_this$phrases$PLEASE_6, this.languages.FRENCH, '❌ Veuillez vérifier votre e-mail.<br/> Consultez votre boîte de réception pour obtenir des instructions.'), _this$phrases$PLEASE_6)), _defineProperty(_defineProperty2, this.phrases.PROFILE_UPDATED_SUCCESSFULLY, (_this$phrases$PROFILE = {}, _defineProperty(_this$phrases$PROFILE, this.languages.SPANISH, '🎉 ¡El perfil ha sido actualizado!'), _defineProperty(_this$phrases$PROFILE, this.languages.FRENCH, '🎉 Le profil a été actualisé avec succès.'), _this$phrases$PROFILE)), _defineProperty(_defineProperty2, this.phrases.RECOVER, (_this$phrases$RECOVER = {}, _defineProperty(_this$phrases$RECOVER, this.languages.SPANISH, 'Recuperar'), _defineProperty(_this$phrases$RECOVER, this.languages.FRENCH, 'Récupérer'), _this$phrases$RECOVER)), _defineProperty(_defineProperty2, this.phrases.REGISTER, (_this$phrases$REGISTE = {}, _defineProperty(_this$phrases$REGISTE, this.languages.SPANISH, 'Registrarse'), _defineProperty(_this$phrases$REGISTE, this.languages.FRENCH, 'S\'inscrire'), _this$phrases$REGISTE)), _defineProperty(_defineProperty2, this.phrases.REQUEST_INVITE, (_this$phrases$REQUEST = {}, _defineProperty(_this$phrases$REQUEST, this.languages.SPANISH, 'Pida una invitación'), _defineProperty(_this$phrases$REQUEST, this.languages.FRENCH, 'Demandez une invitation'), _this$phrases$REQUEST)), _defineProperty(_defineProperty2, this.phrases.REQUEST_NEW_MAGIC_LINK, (_this$phrases$REQUEST2 = {}, _defineProperty(_this$phrases$REQUEST2, this.languages.SPANISH, 'Pedir un nuevo enlace magico.'), _defineProperty(_this$phrases$REQUEST2, this.languages.FRENCH, 'Demandez un nouveau lien magique.'), _this$phrases$REQUEST2)), _defineProperty(_defineProperty2, this.phrases.RESENDING_MAGIC_LINK, (_this$phrases$RESENDI = {}, _defineProperty(_this$phrases$RESENDI, this.languages.SPANISH, 'Reenviando un nuevo enlace magico...'), _defineProperty(_this$phrases$RESENDI, this.languages.FRENCH, 'Renvoyer un nouveau lien magique...'), _this$phrases$RESENDI)), _defineProperty(_defineProperty2, this.phrases.RESET_PASSWORD, (_this$phrases$RESET_P = {}, _defineProperty(_this$phrases$RESET_P, this.languages.SPANISH, 'Restablecer contraseña'), _defineProperty(_this$phrases$RESET_P, this.languages.FRENCH, 'Réinitialiser le mot de passe'), _this$phrases$RESET_P)), _defineProperty(_defineProperty2, this.phrases.SAVE, (_this$phrases$SAVE = {}, _defineProperty(_this$phrases$SAVE, this.languages.SPANISH, 'Guardar'), _defineProperty(_this$phrases$SAVE, this.languages.FRENCH, 'Sauvegarder'), _this$phrases$SAVE)), _defineProperty(_defineProperty2, this.phrases.SELECT, (_this$phrases$SELECT = {}, _defineProperty(_this$phrases$SELECT, this.languages.SPANISH, 'Seleccionar'), _defineProperty(_this$phrases$SELECT, this.languages.FRENCH, 'Sélectionner'), _this$phrases$SELECT)), _defineProperty(_defineProperty2, this.phrases.SEND_MAGIC_LINK, (_this$phrases$SEND_MA = {}, _defineProperty(_this$phrases$SEND_MA, this.languages.SPANISH, 'Mandar enlace mágico'), _defineProperty(_this$phrases$SEND_MA, this.languages.FRENCH, 'Envoyer un lien magique'), _this$phrases$SEND_MA)), _defineProperty(_defineProperty2, this.phrases.SET_PASSWORD, (_this$phrases$SET_PAS = {}, _defineProperty(_this$phrases$SET_PAS, this.languages.SPANISH, 'Establecer contraseña'), _defineProperty(_this$phrases$SET_PAS, this.languages.FRENCH, 'Définir le mot de passe'), _this$phrases$SET_PAS)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN, (_this$phrases$SIGN_IN = {}, _defineProperty(_this$phrases$SIGN_IN, this.languages.SPANISH, 'Iniciar sesión'), _defineProperty(_this$phrases$SIGN_IN, this.languages.FRENCH, 'Se connecter'), _this$phrases$SIGN_IN)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_TITLE, (_this$phrases$SIGN_IN2 = {}, _defineProperty(_this$phrases$SIGN_IN2, this.languages.SPANISH, 'Iniciar Sesión'), _defineProperty(_this$phrases$SIGN_IN2, this.languages.FRENCH, 'Se connecter'), _this$phrases$SIGN_IN2)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_OR_REGISTER, (_this$phrases$SIGN_IN3 = {}, _defineProperty(_this$phrases$SIGN_IN3, this.languages.SPANISH, 'Iniciar sesión o registrarse'), _defineProperty(_this$phrases$SIGN_IN3, this.languages.FRENCH, 'Se connecter ou créer un nouveau compte'), _this$phrases$SIGN_IN3)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_WITH, (_this$phrases$SIGN_IN4 = {}, _defineProperty(_this$phrases$SIGN_IN4, this.languages.SPANISH, 'Iniciar sesión con'), _defineProperty(_this$phrases$SIGN_IN4, this.languages.FRENCH, 'Connectez-vous avec'), _this$phrases$SIGN_IN4)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_WITH_MAGIC_LINK, (_this$phrases$SIGN_IN5 = {}, _defineProperty(_this$phrases$SIGN_IN5, this.languages.SPANISH, 'Iniciar sesion con enlace magico.'), _defineProperty(_this$phrases$SIGN_IN5, this.languages.FRENCH, 'Connectez-vous avec un lien magique'), _this$phrases$SIGN_IN5)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_WITH_PROVIDER, (_this$phrases$SIGN_IN6 = {}, _defineProperty(_this$phrases$SIGN_IN6, this.languages.SPANISH, 'Iniciar sesión con {provider}'), _defineProperty(_this$phrases$SIGN_IN6, this.languages.FRENCH, 'Connectez-vous avec {provider}'), _this$phrases$SIGN_IN6)), _defineProperty(_defineProperty2, this.phrases.SIGN_IN_WITH_USERNAME_AND_PASSWORD, (_this$phrases$SIGN_IN7 = {}, _defineProperty(_this$phrases$SIGN_IN7, this.languages.SPANISH, 'Iniciar sesion con nombre de usuario y contraseña'), _defineProperty(_this$phrases$SIGN_IN7, this.languages.FRENCH, 'Connectez-vous avec nom d\'utilisateur et mot de passe'), _this$phrases$SIGN_IN7)), _defineProperty(_defineProperty2, this.phrases.SIGN_OUT, (_this$phrases$SIGN_OU = {}, _defineProperty(_this$phrases$SIGN_OU, this.languages.SPANISH, 'Salir'), _defineProperty(_this$phrases$SIGN_OU, this.languages.FRENCH, 'Se déconnecter'), _this$phrases$SIGN_OU)), _defineProperty(_defineProperty2, this.phrases.SIGN_UP, (_this$phrases$SIGN_UP = {}, _defineProperty(_this$phrases$SIGN_UP, this.languages.SPANISH, 'Registrarse'), _defineProperty(_this$phrases$SIGN_UP, this.languages.FRENCH, 'S\'inscrire'), _this$phrases$SIGN_UP)), _defineProperty(_defineProperty2, this.phrases.SIGN_UP_WITH, (_this$phrases$SIGN_UP2 = {}, _defineProperty(_this$phrases$SIGN_UP2, this.languages.SPANISH, 'Registrarse con'), _defineProperty(_this$phrases$SIGN_UP2, this.languages.FRENCH, 'Inscrivez-vous avec'), _this$phrases$SIGN_UP2)), _defineProperty(_defineProperty2, this.phrases.SIGN_UP_WITH_PROVIDER, (_this$phrases$SIGN_UP3 = {}, _defineProperty(_this$phrases$SIGN_UP3, this.languages.SPANISH, 'Registrarse con {provider}'), _defineProperty(_this$phrases$SIGN_UP3, this.languages.FRENCH, 'Inscrivez-vous avec {provider}'), _this$phrases$SIGN_UP3)), _defineProperty(_defineProperty2, this.phrases.SIGNED_IN_SUCCESSFULLY, (_this$phrases$SIGNED_ = {}, _defineProperty(_this$phrases$SIGNED_, this.languages.SPANISH, '🎉 ¡Registro completado!'), _defineProperty(_this$phrases$SIGNED_, this.languages.FRENCH, '🎉 Connexion réussie!'), _this$phrases$SIGNED_)), _defineProperty(_defineProperty2, this.phrases.SORRY_CANT_SIGN_UP, (_this$phrases$SORRY_C = {}, _defineProperty(_this$phrases$SORRY_C, this.languages.SPANISH, '❌ Lo sentimos, no fue posible hacer el registro de cuenta con este correo y clave.'), _defineProperty(_this$phrases$SORRY_C, this.languages.FRENCH, '❌ Désolé, nous ne pouvons pas vous inscrire avec une adresse e-mail et un mot de passe pour le moment.'), _this$phrases$SORRY_C)), _defineProperty(_defineProperty2, this.phrases.TELEPHONE, (_this$phrases$TELEPHO = {}, _defineProperty(_this$phrases$TELEPHO, this.languages.SPANISH, 'Teléfono'), _defineProperty(_this$phrases$TELEPHO, this.languages.FRENCH, 'Téléphone'), _this$phrases$TELEPHO)), _defineProperty(_defineProperty2, this.phrases.THIS_MORE_CHARACTERS, (_this$phrases$THIS_MO = {}, _defineProperty(_this$phrases$THIS_MO, this.languages.SPANISH, 'Se ha sobrepasado el limite de {number} caracteres.'), _defineProperty(_this$phrases$THIS_MO, this.languages.FRENCH, 'C\'est plus de {number} caractères'), _this$phrases$THIS_MO)), _defineProperty(_defineProperty2, this.phrases.THIS_MORE_CHARACTER, (_this$phrases$THIS_MO2 = {}, _defineProperty(_this$phrases$THIS_MO2, this.languages.SPANISH, 'Se ha sobrepasado el limite de {number} caractere.'), _defineProperty(_this$phrases$THIS_MO2, this.languages.FRENCH, 'C\'est plus de {number} caractère'), _this$phrases$THIS_MO2)), _defineProperty(_defineProperty2, this.phrases.THIS_MORE_WORDS, (_this$phrases$THIS_MO3 = {}, _defineProperty(_this$phrases$THIS_MO3, this.languages.SPANISH, 'Se ha sobrepasado el limite de {number} palabras'), _defineProperty(_this$phrases$THIS_MO3, this.languages.FRENCH, 'C\'est plus de {number} mots'), _this$phrases$THIS_MO3)), _defineProperty(_defineProperty2, this.phrases.THIS_MORE_WORD, (_this$phrases$THIS_MO4 = {}, _defineProperty(_this$phrases$THIS_MO4, this.languages.SPANISH, 'Se ha sobrepasado el limite de {number} palabra'), _defineProperty(_this$phrases$THIS_MO4, this.languages.FRENCH, 'C\'est plus de {number} mot'), _this$phrases$THIS_MO4)), _defineProperty(_defineProperty2, this.phrases.THIS_LINK_IS_INVALID_EXPIRED_SUPPORT, (_this$phrases$THIS_LI = {}, _defineProperty(_this$phrases$THIS_LI, this.languages.SPANISH, '❌ El enlace ha expirado o es inválido.<br/> Por favor contacte al soporte técnico para obtener un nuevo enlace.'), _defineProperty(_this$phrases$THIS_LI, this.languages.FRENCH, '❌ Ce lien est invalide ou a expiré.<br/> Veuillez contacter le support pour un nouveau lien.'), _this$phrases$THIS_LI)), _defineProperty(_defineProperty2, this.phrases.THIS_LINK_IS_INVALID_EXPIRED_GENERATE, (_this$phrases$THIS_LI2 = {}, _defineProperty(_this$phrases$THIS_LI2, this.languages.SPANISH, '❌ Este enlace es inválido o ha expirado.<br/> Por favor genere un nuevo enlace de recuperación {link_open}aquí{link_open}.'), _defineProperty(_this$phrases$THIS_LI2, this.languages.FRENCH, '❌ Ce lien est invalide ou a expiré.<br/> Veuillez générer un nouveau lien de récupération ici'), _this$phrases$THIS_LI2)), _defineProperty(_defineProperty2, this.phrases.THIS_MAGIC_LINK_INVALID_EXPIRED, (_this$phrases$THIS_MA = {}, _defineProperty(_this$phrases$THIS_MA, this.languages.SPANISH, '❌ Este enlace magico es invalido o ha expirado.'), _defineProperty(_this$phrases$THIS_MA, this.languages.FRENCH, '❌ Ce lien magique est invalide ou a expiré.'), _this$phrases$THIS_MA)), _defineProperty(_defineProperty2, this.phrases.VERIFYING, (_this$phrases$VERIFYI = {}, _defineProperty(_this$phrases$VERIFYI, this.languages.SPANISH, 'Verificando ...'), _defineProperty(_this$phrases$VERIFYI, this.languages.FRENCH, 'Vérification ...'), _this$phrases$VERIFYI)), _defineProperty(_defineProperty2, this.phrases.YOUR_EMAIL_NOT_VERIFIED_CHECK_INBOX, (_this$phrases$YOUR_EM = {}, _defineProperty(_this$phrases$YOUR_EM, this.languages.SPANISH, 'Su correo electrónico ({email}) no ha sido verificado. Por favor revise su cuenta de correo para las seguir las instrucciones o haga {link_open}click aquí{link_close} para reenviar el correo de verificación.'), _defineProperty(_this$phrases$YOUR_EM, this.languages.FRENCH, 'Votre adresse e-mail ({email}) n\'est pas vérifiée. Consultez votre boîte de réception pour obtenir des instructions ou {link_open}cliquez ici{link_close} pour renvoyer l\'e-mail de vérification.'), _this$phrases$YOUR_EM)), _defineProperty2));
  }

  _createClass(BooyaTranslations, [{
    key: "parseLanguage",
    value: function parseLanguage(lang) {
      var _this = this;

      var _ref = (lang || '').match(/^([A-Za-z]{2})([-_]\w+)*$/i) || [],
          _ref2 = _slicedToArray(_ref, 2),
          parsedLang = _ref2[1];

      return parsedLang && Object.keys(this.languages).map(function (key) {
        return _this.languages[key];
      }).includes(parsedLang) ? parsedLang : null;
    }
  }, {
    key: "detectLanguage",
    value: function detectLanguage() {
      return this.parseLanguage($('html').attr('lang'));
    }
  }, {
    key: "resolvedLanguage",
    value: function resolvedLanguage() {
      return window.booyaConfig && window.booyaConfig.language && this.parseLanguage(window.booyaConfig.language);
    }
  }, {
    key: "getTranslation",
    value: function getTranslation(phrase) {
      var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var language = this.resolvedLanguage() || this.languages.ENGLISH;
      var translation = this.translations[phrase] && this.translations[phrase][language] || phrase || '';

      if (args && _typeof(args) === 'object') {
        for (var _i2 = 0, _Object$keys = Object.keys(args); _i2 < _Object$keys.length; _i2++) {
          var name = _Object$keys[_i2];
          translation = translation.replaceAll("{".concat(name, "}"), args[name]);
        }
      }

      return translation;
    }
  }, {
    key: "getVarTranslation",
    value: function getVarTranslation(data, key) {
      var language = this.resolvedLanguage() || this.languages.ENGLISH;
      return data && (data[language] && data[language][key] || data[this.languages.ENGLISH] && data[this.languages.ENGLISH][key] || data[key]) || '';
    }
  }]);

  return BooyaTranslations;
}();

var BooyaProviders = /*#__PURE__*/function () {
  function BooyaProviders() {
    var _defineProperty3;

    _classCallCheck(this, BooyaProviders);

    _defineProperty(this, "names", {
      GOOGLE: 'google',
      FACEBOOK: 'facebook',
      LINKEDIN: 'linkedin',
      TWITTER: 'twitter',
      GITHUB: 'github',
      EMAIL: 'email'
    });

    _defineProperty(this, "translations", new BooyaTranslations());

    _defineProperty(this, "map", (_defineProperty3 = {}, _defineProperty(_defineProperty3, this.names.GOOGLE, {
      name: 'Google',
      logo: 'google.svg'
    }), _defineProperty(_defineProperty3, this.names.FACEBOOK, {
      name: 'Facebook',
      logo: 'facebook.svg'
    }), _defineProperty(_defineProperty3, this.names.LINKEDIN, {
      name: 'LinkedIn',
      logo: 'linkedin.svg'
    }), _defineProperty(_defineProperty3, this.names.TWITTER, {
      name: 'Twitter',
      logo: 'twitter.svg'
    }), _defineProperty(_defineProperty3, this.names.GITHUB, {
      name: 'Github',
      logo: 'github.svg'
    }), _defineProperty(_defineProperty3, this.names.EMAIL, {
      name: this.translations.getTranslation(this.translations.phrases.EMAIL),
      logo: 'envelope.svg'
    }), _defineProperty3));
  }

  _createClass(BooyaProviders, [{
    key: "getList",
    value: function getList() {
      return Object.keys(this.map);
    }
  }, {
    key: "getName",
    value: function getName(provider) {
      var _ref3 = this.map[provider] || {},
          name = _ref3.name;

      return name;
    }
  }, {
    key: "getLogo",
    value: function getLogo(provider) {
      var _ref4 = this.map[provider] || {},
          logo = _ref4.logo;

      return "https://cdn.jsdelivr.net/npm/@inboundlabs/booya-ui@latest/dist/images/".concat(logo);
    }
  }]);

  return BooyaProviders;
}();

var BooyaWidgets = /*#__PURE__*/function () {
  function BooyaWidgets() {
    _classCallCheck(this, BooyaWidgets);

    _defineProperty(this, "translations", new BooyaTranslations());

    _defineProperty(this, "providers", new BooyaProviders());

    _defineProperty(this, "selectors", {
      modal: '__booya-modal-overlay',
      modalTop: '__booya-modal-overlay-top',
      modalNoClose: '__booya-modal-overlay-no-close',
      modalAuthWidgets: '__booya-modal-overlay-auth-widgets',
      authWidgetsWrapper: '__booya-auth-widgets-wrapper',
      authWidgetSection: '__booya-auth-widget-section',
      authWidgetSectionSwitch: '__booya-auth-widget-section-switch',
      link: '__booya-link',
      banner: '__booya-banner',
      notice: '__booya-notice'
    });

    _defineProperty(this, "banners", {
      INFO: 'info',
      SUCCESS: 'success',
      WARN: 'warn',
      DANGER: 'danger'
    });

    _defineProperty(this, "notices", {
      INFO: 'info',
      SUCCESS: 'success',
      WARN: 'warn',
      DANGER: 'danger'
    });

    _defineProperty(this, "sections", {
      INVITE: 'invite',
      SIGNIN: 'signin',
      SIGNUP: 'signup',
      RECOVER: 'recover',
      RESET: 'reset',
      MAGIC_LINK: 'magic-link'
    });

    _defineProperty(this, "forms", {
      LOGIN: 'login',
      MAGIC_LINK: 'magic_link',
      REGISTER: 'register',
      RECOVER: 'recover',
      RESET: 'reset',
      SET: 'set',
      PROFILE: 'profile'
    });

    _defineProperty(this, "formLabels", {
      TITLE: 'title',
      EMAIL: 'email',
      PASSWORD: 'password',
      CONFIRM_PASSWORD: 'confirm_password',
      SUBMIT: 'submit',
      SWITCH_PROMPT: 'switch_prompt',
      SWITCH_CTA: 'switch_cta',
      BACK: 'back'
    });
  }

  _createClass(BooyaWidgets, [{
    key: "getFormLabel",
    value: function getFormLabel(formName, labelName) {
      var formConfig = window.booyaConfig && window.booyaConfig.forms && window.booyaConfig.forms[formName],
          customLabels = formConfig && formConfig.labels;
      return this.translations.getVarTranslation(customLabels, labelName);
    }
    /* Form Widgets */

  }, {
    key: "renderFormField",
    value: function renderFormField(input, name, settings) {
      var input_type = settings.type,
          value = settings.value,
          required = settings.required,
          placeholder = settings.placeholder,
          options = settings.options,
          selected = settings.selected,
          label = settings.label,
          help_text = settings.help_text,
          character_limit = settings.character_limit,
          word_limit = settings.word_limit,
          requiredIndicator = settings.requiredIndicator,
          dataAttributes = settings.data;
      var dataAttributesMarkup = Object.keys(dataAttributes || {}).map(function (key) {
        return "data-".concat(key, "=\"").concat(dataAttributes[key], "\"");
      }).join(' ');

      if (input === 'input' && ['checkbox', 'radio'].includes(input_type)) {
        var renderCheckBoxOrRadio = function renderCheckBoxOrRadio(inputVal, inputLabel) {
          return "\n<fieldset ".concat(required ? "required" : '', " class=\"").concat(input_type, "\">\n  <input type=\"").concat(input_type, "\" name=\"").concat(name, "\" value=\"").concat(inputVal, "\" ").concat(dataAttributes && dataAttributes.label ? '' : "data-label=\"".concat(label || '', "\""), " ").concat(dataAttributesMarkup, ">\n  <span class=\"checkmark\"></span>\n  <label>").concat(inputLabel || '', " ").concat(required ? '*' : '', "</label>\n</fieldset>\n                ");
        };

        if (Array.isArray(options) && options.length) {
          return "\n<fieldset>\n    <label>".concat(label, "</label>\n    <div class=\"choice-options\">\n    ").concat(options.map(function (i) {
            return renderCheckBoxOrRadio(i.id, i.name);
          }).join('\n'), "\n    </div>\n</fieldset>\n");
        }

        return renderCheckBoxOrRadio(value, label);
      }

      var styleFixer = 'style="width: 100% !important;"';
      var inputHtml = '';

      switch (input) {
        case 'textarea':
          inputHtml = "\n<textarea name=\"".concat(name, "\"\n                  ").concat(required ? "required" : '', "\n                  ").concat(character_limit ? "data-character-limit=\"".concat(character_limit, "\"") : '', "\n                  ").concat(word_limit ? "data-word-limit=\"".concat(word_limit, "\"") : '', "\n                  ").concat(placeholder ? "placeholder=\"".concat(placeholder).concat(required && !label && ' *' || '', "\"") : '', "\n                  ").concat(styleFixer, "\n                  >").concat(value || '', "</textarea>\n            ");
          break;

        case 'input':
        case 'hidden':
          inputHtml = "\n<input type=\"".concat(input_type || 'text', "\"\n               name=\"").concat(name, "\"\n               ").concat(required ? "required" : '', "\n               ").concat(character_limit ? "data-character-limit=\"".concat(character_limit, "\"") : '', "\n               ").concat(word_limit ? "data-word-limit=\"".concat(word_limit, "\"") : '', "\n               ").concat(value ? "value=\"".concat(value, "\"") : '', "\n               ").concat(placeholder ? "placeholder=\"".concat(placeholder).concat(required && !label && (typeof requiredIndicator !== 'boolean' || requiredIndicator) && ' *' || '', "\"") : '', "\n               ").concat(dataAttributesMarkup, "\n               ").concat(styleFixer, "\n        >\n            ");
          break;

        case 'select':
        case 'multi-select':
          inputHtml = "\n<select name=\"".concat(name, "\"\n        ").concat(input === "multi-select" ? "id=\"".concat(name, "-select\"") : '', "\n        ").concat(dataAttributesMarkup, "\n        ").concat(styleFixer, "\n        >\n   <option value=\"\">").concat(placeholder || "- ".concat(this.translations.getTranslation(this.translations.phrases.SELECT), " -"), "</option> \n    ").concat(options ? options.map(function (option) {
            return "\n    <option value=\"".concat(option.id, "\"\n        ").concat(selected === option.id || value === option.id ? "selected" : '', "\n        ").concat(input_type === "multi-select" ? "id=\"".concat(option.name, "-").concat(option.id, "\"") : '', ">\n        ").concat(option.name, "\n    </option>\n        ");
          }) : '', "\n</select>\n            ");
          break;

        default:
          inputHtml = input;
          break;
      }

      var isHidden = input_type === 'hidden';

      if (isHidden) {
        return inputHtml;
      }

      return "\n<fieldset ".concat(required ? "required" : '', ">\n    ").concat(label ? "\n    <label>".concat(label, " ").concat(required ? '*' : "\n        <span class=\"optional\">(".concat(this.translations.getTranslation(this.translations.phrases.OPTIONAL), ")</span>\n    "), "</label>\n    ") : '', "\n    \n    ").concat(help_text ? "\n    <label>\n        <legend>".concat(help_text, "</legend>\n    </label>\n    ") : '', "\n    \n    <div>\n        ").concat(inputHtml, "\n    </div>\n</fieldset>\n    ");
    }
  }, {
    key: "renderDivider",
    value: function renderDivider() {
      var label = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      return "\n<div class=\"__booya-section-separator\">\n    <div class=\"__booya-section-separator-line\"></div>\n    ".concat(label ? "\n    <div class=\"__booya-section-separator-text\">".concat(label, "</div>\n    <div class=\"__booya-section-separator-line\"></div>\n    ") : '', "\n</div>\n        ");
    }
  }, {
    key: "renderOAuthButton",
    value: function renderOAuthButton(provider, options) {
      var _ref5 = options || {},
          label = _ref5.label,
          redirect_url = _ref5.redirect_url,
          error_redirect_url = _ref5.error_redirect_url,
          _ref5$action = _ref5.action,
          action = _ref5$action === void 0 ? this.translations.getTranslation(this.translations.phrases.SIGN_IN_WITH) : _ref5$action,
          name = this.providers.getName(provider),
          logo = this.providers.getLogo(provider);

      var nextUrl = booya && booya.getUrlParameter('next') || window.booyaConfig && window.booyaConfig.memberUrl || location.href || '';
      var guestUrl = window.booyaConfig && window.booyaConfig.guestUrl || location.href || '';
      var url = "".concat(window.booyaConfig && window.booyaConfig.apiRoot || "https://auth.booya.io".concat(window.booyaConfig && window.booyaConfig.appID ? "/".concat(window.booyaConfig.appID) : ''), "/auth/signin/").concat(provider, "/?grant_type=code&redirect_uri=").concat(redirect_url || nextUrl || '', "&redirect_uri_error=").concat(error_redirect_url || location.href || guestUrl || '');
      return "\n<a href=\"".concat(provider === this.providers.names.EMAIL ? '#' : url, "\" \n   class=\"__booya-btn __booya-btn-outline __booya-btn-signin __booya-btn-signin-").concat(provider, " ").concat(provider === this.providers.names.EMAIL ? '__booya-signin-email-open' : '', "\">\n    <img src=\"").concat(logo, "\" alt=\"").concat(name, "\"/>").concat(label || "".concat(action, " ").concat(name), " \n</a>\n        ");
    }
    /* Authentication */

  }, {
    key: "renderAuthFormValidation",
    value: function renderAuthFormValidation(error, success, warning) {
      return "\n<div class=\"form-success\" style=\"display: none\">\n    ".concat(success || '', "\n</div>\n\n<div class=\"form-error\" style=\"display: none\" data-error=\"").concat(error || '', "\">\n    ").concat(error || '', "\n</div>\n\n<div class=\"form-validation-error\" style=\"display: none\">\n    ").concat(warning || this.translations.getTranslation(this.translations.phrases.PLEASE_FIX_ERRORS), "\n</div>\n    ");
    }
  }, {
    key: "renderAuthForm",
    value: function renderAuthForm(type, title, fields, action, options) {
      var _ref6 = options || {},
          error = _ref6.error,
          success = _ref6.success,
          warning = _ref6.warning,
          header = _ref6.header,
          footer = _ref6.footer,
          hideAction = _ref6.hideAction,
          _ref6$repeatValidatio = _ref6.repeatValidation,
          repeatValidation = _ref6$repeatValidatio === void 0 ? false : _ref6$repeatValidatio,
          target = _ref6.target;

      var validation = this.renderAuthFormValidation(error, success, warning);
      var cleanedTitle = title ? /^\s?<.*>\s?$/mi.test(title) ? title : "<h3>".concat(title, "</h3>") : '';
      var markup = "\n<form name=\"".concat(type, "\" class=\"__booya-form __booya-").concat(type, "-form\">\n    ").concat(cleanedTitle || '', "\n    \n    ").concat(header || '', "\n    \n    ").concat(validation || '', "\n    \n    ").concat(fields || '', "\n    \n    ").concat(footer || '', "\n\n    ").concat(repeatValidation && validation || '', "\n    \n    ").concat(hideAction ? '' : "\n    <div class=\"__booya-form-action\">\n        <button type=\"submit\" class=\"__booya-btn\">\n            ".concat(action, "\n        </button>\n    </div>\n    "), "\n</form>\n    ");

      if (target) {
        $(target).html(markup);

        if (window.booya) {
          window.booya.initUI();
        }

        return;
      }

      return markup;
    }
    /* Verify */

  }, {
    key: "renderVerifyForm",
    value: function renderVerifyForm(title, fields, action, options) {
      var _ref7 = options || {},
          error = _ref7.error,
          success = _ref7.success,
          header = _ref7.header,
          footer = _ref7.footer,
          _ref7$fieldOverrides = _ref7.fieldOverrides,
          fieldOverrides = _ref7$fieldOverrides === void 0 ? {} : _ref7$fieldOverrides,
          rest = _objectWithoutProperties(_ref7, _excluded);

      return this.renderAuthForm('verify', title || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.SIGN_IN_OR_REGISTER), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'email', _objectSpread({
        type: 'email',
        label: this.translations.getTranslation(this.translations.phrases.EMAIL),
        placeholder: this.translations.getTranslation(this.translations.phrases.EMAIL),
        required: true
      }, fieldOverrides.email || {})), "\n        "), action || this.translations.getTranslation(this.translations.phrases.NEXT), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_SOMETHING_WRONG),
        success: success || this.translations.getTranslation(this.translations.phrases.EMAIL_VERIFIED_SUCCESSFULLY),
        header: header,
        footer: footer
      }, rest));
    }
    /* Sign In */

  }, {
    key: "renderSignInForm",
    value: function renderSignInForm(title, fields, action, options) {
      var _ref8 = options || {},
          error = _ref8.error,
          success = _ref8.success,
          header = _ref8.header,
          footer = _ref8.footer,
          _ref8$fieldOverrides = _ref8.fieldOverrides,
          fieldOverrides = _ref8$fieldOverrides === void 0 ? {} : _ref8$fieldOverrides,
          rest = _objectWithoutProperties(_ref8, _excluded2);

      return this.renderAuthForm('signin', title || this.getFormLabel(this.forms.LOGIN, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.SIGN_IN_TITLE), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'email', _objectSpread({
        type: 'email',
        label: this.getFormLabel(this.forms.LOGIN, this.formLabels.EMAIL) || this.translations.getTranslation(this.translations.phrases.EMAIL),
        placeholder: this.translations.getTranslation(this.translations.phrases.EMAIL),
        required: true
      }, fieldOverrides.email || {})), "\n        ").concat(this.renderFormField('input', 'password', _objectSpread({
        type: 'password',
        label: this.getFormLabel(this.forms.LOGIN, this.formLabels.PASSWORD) || this.translations.getTranslation(this.translations.phrases.PASSWORD),
        placeholder: this.translations.getTranslation(this.translations.phrases.PASSWORD),
        required: true
      }, fieldOverrides.password || {})), "\n        "), action || this.getFormLabel(this.forms.LOGIN, this.formLabels.SUBMIT) || this.translations.getTranslation(this.translations.phrases.SIGN_IN_TITLE), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_SIGN_IN),
        success: success || this.translations.getTranslation(this.translations.phrases.SIGNED_IN_SUCCESSFULLY),
        header: header,
        footer: footer
      }, rest));
    }
    /* Sign Up */

  }, {
    key: "renderSignUpForm",
    value: function renderSignUpForm(title, fields, action, options) {
      var _this2 = this;

      var _ref9 = options || {},
          error = _ref9.error,
          success = _ref9.success,
          header = _ref9.header,
          footer = _ref9.footer,
          _ref9$includeTel = _ref9.includeTel,
          includeTel = _ref9$includeTel === void 0 ? false : _ref9$includeTel,
          _ref9$includeLabels = _ref9.includeLabels,
          includeLabels = _ref9$includeLabels === void 0 ? true : _ref9$includeLabels,
          _ref9$repeatValidatio = _ref9.repeatValidation,
          repeatValidation = _ref9$repeatValidatio === void 0 ? true : _ref9$repeatValidatio,
          _ref9$fieldOverrides = _ref9.fieldOverrides,
          fieldOverrides = _ref9$fieldOverrides === void 0 ? {} : _ref9$fieldOverrides,
          rest = _objectWithoutProperties(_ref9, _excluded3);

      var hsForm = window.booyaConfig && window.booyaConfig.forms && window.booyaConfig.forms.registration;
      var hsFormMarkup = '',
          hsAction = '';

      if (hsForm) {
        hsFormMarkup = [].concat(_toConsumableArray(hsForm.fields || []), _toConsumableArray(hsForm.consentFields || [])).map(function (field) {
          if (field.html) {
            return field.html;
          }

          if (field.name) {
            var input = field.input,
                name = field.name,
                fieldSettings = _objectWithoutProperties(field, _excluded4);

            return _this2.renderFormField(input, name, _objectSpread(_objectSpread({}, fieldSettings || {}), {}, {
              label: fieldSettings && fieldSettings.label && _this2.translations.getTranslation(fieldSettings.label) || '',
              placeholder: fieldSettings && fieldSettings.placeholder && _this2.translations.getTranslation(fieldSettings.placeholder) || ''
            }));
          }

          return '';
        }).join('').trim();
        hsAction = hsForm.submitText || '';
      }

      return this.renderAuthForm('signup', title || this.getFormLabel(this.forms.REGISTER, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.REGISTER), "</h3>"), fields || hsFormMarkup || "\n        ".concat(this.renderFormField('input', 'email', _objectSpread({
        type: 'email',
        label: includeLabels && this.translations.getTranslation(this.translations.phrases.EMAIL) || '',
        placeholder: this.translations.getTranslation(this.translations.phrases.EMAIL),
        required: true
      }, fieldOverrides.email || {})), "\n        ").concat(this.renderFormField('input', 'password', _objectSpread({
        type: 'password',
        label: includeLabels && this.translations.getTranslation(this.translations.phrases.PASSWORD) || '',
        placeholder: this.translations.getTranslation(this.translations.phrases.PASSWORD),
        required: true
      }, fieldOverrides.password || {})), "\n        ").concat(this.renderFormField('input', 'first_name', _objectSpread({
        type: 'text',
        label: includeLabels && this.translations.getTranslation(this.translations.phrases.FIRST_NAME) || '',
        placeholder: this.translations.getTranslation(this.translations.phrases.FIRST_NAME),
        required: true
      }, fieldOverrides.first_name || {})), "\n        ").concat(this.renderFormField('input', 'last_name', _objectSpread({
        type: 'text',
        label: includeLabels && this.translations.getTranslation(this.translations.phrases.LAST_NAME) || '',
        placeholder: this.translations.getTranslation(this.translations.phrases.LAST_NAME),
        required: true
      }, fieldOverrides.last_name || {})), "\n        ").concat(includeTel ? this.renderFormField('input', 'telephone', _objectSpread({
        type: 'tel',
        label: includeLabels && this.translations.getTranslation(this.translations.phrases.PHONE_NUMBER) || '',
        placeholder: this.translations.getTranslation(this.translations.phrases.PHONE_NUMBER),
        required: false
      }, fieldOverrides.telephone || {})) : '', "\n        "), action || hsAction || this.translations.getTranslation(this.translations.phrases.REGISTER), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.SORRY_CANT_SIGN_UP),
        success: success || this.translations.getTranslation(this.translations.phrases.ACCOUNT_CREATED_CHECK_INBOX),
        header: header,
        footer: footer,
        repeatValidation: repeatValidation
      }, rest));
    }
    /* Complete Profile */

  }, {
    key: "renderProfileForm",
    value: function renderProfileForm(title, fields, action, options) {
      var _this3 = this;

      var _ref10 = options || {},
          error = _ref10.error,
          success = _ref10.success,
          header = _ref10.header,
          footer = _ref10.footer,
          _ref10$includeTel = _ref10.includeTel,
          includeTel = _ref10$includeTel === void 0 ? true : _ref10$includeTel,
          _ref10$repeatValidati = _ref10.repeatValidation,
          repeatValidation = _ref10$repeatValidati === void 0 ? false : _ref10$repeatValidati,
          _ref10$fieldOverrides = _ref10.fieldOverrides,
          fieldOverrides = _ref10$fieldOverrides === void 0 ? {} : _ref10$fieldOverrides,
          rest = _objectWithoutProperties(_ref10, _excluded5);

      var user = window.user || {};
      var hsForm = window.booyaConfig && window.booyaConfig.forms && window.booyaConfig.forms.profile;
      var hsFormMarkup = '',
          hsAction = '';

      if (hsForm) {
        hsFormMarkup = [].concat(_toConsumableArray(hsForm.fields || []), _toConsumableArray(hsForm.consentFields || [])).map(function (field) {
          if (field.html) {
            return field.html;
          }

          if (field.name) {
            var input = field.input,
                name = field.name,
                fieldSettings = _objectWithoutProperties(field, _excluded6);

            return _this3.renderFormField(input, name, _objectSpread(_objectSpread({}, fieldSettings || {}), {}, {
              label: fieldSettings && fieldSettings.label && _this3.translations.getTranslation(fieldSettings.label) || '',
              placeholder: fieldSettings && fieldSettings.placeholder && _this3.translations.getTranslation(fieldSettings.placeholder) || ''
            }, user[name] ? {
              value: user[name] || ''
            } : {}));
          }

          return '';
        }).join('').trim();
        hsAction = hsForm.submitText;
      }

      return this.renderAuthForm('profile', title || this.getFormLabel(this.forms.PROFILE, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.COMPLETE_PROFILE), "</h3>"), fields || hsFormMarkup || "\n        ".concat(this.renderFormField('input', 'first_name', _objectSpread({
        type: 'text',
        label: this.translations.getTranslation(this.translations.phrases.FIRST_NAME),
        placeholder: this.translations.getTranslation(this.translations.phrases.FIRST_NAME),
        required: true,
        value: user.first_name || ''
      }, fieldOverrides.first_name || {})), "\n        ").concat(this.renderFormField('input', 'last_name', _objectSpread({
        type: 'text',
        label: this.translations.getTranslation(this.translations.phrases.LAST_NAME),
        placeholder: this.translations.getTranslation(this.translations.phrases.LAST_NAME),
        required: true,
        value: user.last_name || ''
      }, fieldOverrides.last_name || {})), "\n        ").concat(includeTel ? this.renderFormField('input', 'telephone', {
        type: 'tel',
        label: this.translations.getTranslation(this.translations.phrases.PHONE_NUMBER),
        placeholder: this.translations.getTranslation(this.translations.phrases.PHONE_NUMBER),
        required: false,
        value: user.telephone || ''
      }) : '', "\n        "), action || hsAction || this.translations.getTranslation(this.translations.phrases.SAVE), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_SAVE_PROFILE),
        success: success || this.translations.getTranslation(this.translations.phrases.PROFILE_UPDATED_SUCCESSFULLY),
        header: header,
        footer: footer,
        repeatValidation: repeatValidation
      }, rest));
    }
    /* Magic Link */

  }, {
    key: "renderMagicLinkForm",
    value: function renderMagicLinkForm(title, fields, action, options) {
      var _ref11 = options || {},
          error = _ref11.error,
          success = _ref11.success,
          header = _ref11.header,
          footer = _ref11.footer,
          _ref11$fieldOverrides = _ref11.fieldOverrides,
          fieldOverrides = _ref11$fieldOverrides === void 0 ? {} : _ref11$fieldOverrides,
          rest = _objectWithoutProperties(_ref11, _excluded7);

      return this.renderAuthForm('magic-link', title || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.SIGN_IN_TITLE), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'email', _objectSpread({
        type: 'email',
        label: this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.EMAIL) || this.translations.getTranslation(this.translations.phrases.EMAIL),
        placeholder: this.translations.getTranslation(this.translations.phrases.EMAIL),
        required: true
      }, fieldOverrides.email || {})), "\n        "), action || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.SUBMIT) || this.translations.getTranslation(this.translations.phrases.SEND_MAGIC_LINK), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_FIND_ACCOUNT_EMAIL),
        success: success || this.translations.getTranslation(this.translations.phrases.PLEASE_CHECK_INBOX_INSTRUCTIONS),
        header: header,
        footer: footer
      }, rest));
    }
    /* Recover Account */

  }, {
    key: "renderRecoverForm",
    value: function renderRecoverForm(title, fields, action, options) {
      var _ref12 = options || {},
          error = _ref12.error,
          success = _ref12.success,
          header = _ref12.header,
          footer = _ref12.footer,
          _ref12$fieldOverrides = _ref12.fieldOverrides,
          fieldOverrides = _ref12$fieldOverrides === void 0 ? {} : _ref12$fieldOverrides,
          rest = _objectWithoutProperties(_ref12, _excluded8);

      return this.renderAuthForm('recover-account', title || this.getFormLabel(this.forms.RECOVER, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.ACCOUNT_RECOVERY), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'email', _objectSpread({
        type: 'email',
        label: this.getFormLabel(this.forms.RECOVER, this.formLabels.EMAIL) || this.translations.getTranslation(this.translations.phrases.EMAIL),
        placeholder: this.translations.getTranslation(this.translations.phrases.EMAIL),
        required: true
      }, fieldOverrides.email || {})), "\n        "), action || this.getFormLabel(this.forms.RECOVER, this.formLabels.SUBMIT) || this.translations.getTranslation(this.translations.phrases.RECOVER), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_ACCOUNT_RECOVERY),
        success: success || this.translations.getTranslation(this.translations.phrases.PLEASE_CHECK_INBOX_INSTRUCTIONS),
        header: header,
        footer: footer
      }, rest));
    }
    /* Set Password */

  }, {
    key: "renderSetPasswordForm",
    value: function renderSetPasswordForm(title, fields, action, options) {
      var _ref13 = options || {},
          error = _ref13.error,
          success = _ref13.success,
          header = _ref13.header,
          footer = _ref13.footer,
          _ref13$fieldOverrides = _ref13.fieldOverrides,
          fieldOverrides = _ref13$fieldOverrides === void 0 ? {} : _ref13$fieldOverrides,
          rest = _objectWithoutProperties(_ref13, _excluded9);

      return this.renderAuthForm('set-password', title || this.getFormLabel(this.forms.SET, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.SET_PASSWORD), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'new_password', _objectSpread({
        type: 'password',
        label: this.getFormLabel(this.forms.SET, this.formLabels.PASSWORD) || this.translations.getTranslation(this.translations.phrases.PASSWORD),
        placeholder: this.translations.getTranslation(this.translations.phrases.PASSWORD),
        required: true
      }, fieldOverrides.new_password || {})), "\n        ").concat(this.renderFormField('input', 'confirm_password', _objectSpread({
        type: 'password',
        label: this.getFormLabel(this.forms.SET, this.formLabels.CONFIRM_PASSWORD) || this.translations.getTranslation(this.translations.phrases.CONFIRM_PASSWORD),
        placeholder: this.translations.getTranslation(this.translations.phrases.CONFIRM_PASSWORD),
        required: true
      }, fieldOverrides.confirm_password || {})), "\n        "), action || this.getFormLabel(this.forms.SET, this.formLabels.SUBMIT) || this.translations.getTranslation(this.translations.phrases.SAVE), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_SET_PASSWORD),
        success: success || this.translations.getTranslation(this.translations.phrases.PASSWORD_SET_SUCCESSFULLY),
        header: header,
        footer: footer
      }, rest));
    }
    /* Reset Password */

  }, {
    key: "renderResetForm",
    value: function renderResetForm(title, fields, action, options) {
      var _ref14 = options || {},
          error = _ref14.error,
          success = _ref14.success,
          header = _ref14.header,
          footer = _ref14.footer,
          _ref14$fieldOverrides = _ref14.fieldOverrides,
          fieldOverrides = _ref14$fieldOverrides === void 0 ? {} : _ref14$fieldOverrides,
          rest = _objectWithoutProperties(_ref14, _excluded10);

      return this.renderAuthForm('reset-password', title || this.getFormLabel(this.forms.RESET, this.formLabels.TITLE) || "<h3>".concat(this.translations.getTranslation(this.translations.phrases.RESET_PASSWORD), "</h3>"), fields || "\n        ".concat(this.renderFormField('input', 'new_password', _objectSpread({
        type: 'password',
        label: this.getFormLabel(this.forms.RESET, this.formLabels.PASSWORD) || this.translations.getTranslation(this.translations.phrases.NEW_PASSWORD),
        placeholder: this.translations.getTranslation(this.translations.phrases.NEW_PASSWORD),
        required: true
      }, fieldOverrides.new_password || {})), "\n        ").concat(this.renderFormField('input', 'confirm_password', _objectSpread({
        type: 'password',
        label: this.getFormLabel(this.forms.RESET, this.formLabels.CONFIRM_PASSWORD) || this.translations.getTranslation(this.translations.phrases.CONFIRM_PASSWORD),
        placeholder: this.translations.getTranslation(this.translations.phrases.CONFIRM_PASSWORD),
        required: true
      }, fieldOverrides.confirm_password || {})), "\n        "), action || this.getFormLabel(this.forms.RESET, this.formLabels.SUBMIT) || this.translations.getTranslation(this.translations.phrases.SAVE), _objectSpread({
        error: error || this.translations.getTranslation(this.translations.phrases.OOPS_CHANGE_PASSWORD),
        success: success || this.translations.getTranslation(this.translations.phrases.PASSWORD_UPDATED_SUCCESSFULLY),
        header: header,
        footer: footer
      }, rest));
    }
    /* Modals */

  }, {
    key: "renderModal",
    value: function renderModal(title, content, options) {
      var _ref15 = options || {},
          className = _ref15.className,
          target = _ref15.target,
          _ref15$isOpen = _ref15.isOpen,
          isOpen = _ref15$isOpen === void 0 ? false : _ref15$isOpen,
          _ref15$canClose = _ref15.canClose,
          canClose = _ref15$canClose === void 0 ? true : _ref15$canClose,
          _ref15$isTop = _ref15.isTop,
          isTop = _ref15$isTop === void 0 ? false : _ref15$isTop;

      var markup = "\n<div class=\"".concat(this.selectors.modal, " ").concat(!canClose && this.selectors.modalNoClose || '', " ").concat(isTop && this.selectors.modalTop || '', " ").concat(className || '', "\" style=\"display: ").concat(isOpen ? 'block' : 'none', "\">\n  <div class=\"__booya-modal\">\n    <div class=\"__booya-modal-header\">\n      ").concat(title || '', "\n      \n      ").concat(canClose && "\n      <div class=\"__booya-close\">\n        <svg viewBox=\"0 0 14 14\" xmlns=\"http://www.w3.org/2000/svg\">\n          <path d=\"M14.5,1.5l-13,13m0-13,13,13\" transform=\"translate(-1 -1)\"></path>\n        </svg>\n      </div>\n      " || '', "\n    </div>\n    <div class=\"__booya-modal-content\">\n        ").concat(content || '', "\n    </div>\n  </div>\n</div>\n    ");

      if (target || isOpen) {
        if (target) {
          $(target).html(markup);
        } else {
          $('body').append(markup);
        }

        if (window.booya) {
          window.booya.initUI();
        }

        return;
      }

      return markup;
    }
  }, {
    key: "closeModal",
    value: function closeModal() {
      var child = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      var closableModalSelector = ".".concat(this.selectors.modal, ":not(.").concat(this.selectors.modalNoClose, ")");
      var modal = child ? $(child).closest(closableModalSelector) : $(".".concat(this.selectors.modal));
      modal.hide();
    }
    /* Alias for closeModal for legacy support */

  }, {
    key: "removeModal",
    value: function removeModal() {
      var child = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : null;
      this.closeModal(child);
    }
    /* Complete Auth Widgets */

  }, {
    key: "renderAuthWidgets",
    value: function renderAuthWidgets(options) {
      var _this4 = this;

      var _ref16 = options || {},
          header = _ref16.header,
          footer = _ref16.footer,
          _ref16$signIn = _ref16.signIn,
          signIn = _ref16$signIn === void 0 ? true : _ref16$signIn,
          _ref16$signUp = _ref16.signUp,
          signUp = _ref16$signUp === void 0 ? true : _ref16$signUp,
          _ref16$recover = _ref16.recover,
          recover = _ref16$recover === void 0 ? true : _ref16$recover,
          _ref16$verify = _ref16.verify,
          verify = _ref16$verify === void 0 ? false : _ref16$verify,
          _ref16$multiStep = _ref16.multiStep,
          multiStep = _ref16$multiStep === void 0 ? false : _ref16$multiStep,
          _ref16$magicLink = _ref16.magicLink,
          magicLink = _ref16$magicLink === void 0 ? false : _ref16$magicLink,
          _ref16$switches = _ref16.switches,
          switches = _ref16$switches === void 0 ? null : _ref16$switches,
          _ref16$target = _ref16.target,
          target = _ref16$target === void 0 ? null : _ref16$target,
          _ref16$className = _ref16.className,
          className = _ref16$className === void 0 ? '' : _ref16$className,
          _ref16$modal = _ref16.modal,
          modal = _ref16$modal === void 0 ? null : _ref16$modal,
          _ref16$section = _ref16.section,
          originalSection = _ref16$section === void 0 ? null : _ref16$section;

      var onlyMagicLink = booyaConfig && booyaConfig.magicLink && booyaConfig.magicLink.only || booyaConfig && booyaConfig.onlyMagicLink || false;
      var magicLinkEnabled = onlyMagicLink || booyaConfig && booyaConfig.magicLink && booyaConfig.magicLink.enabled || false;

      if (magicLinkEnabled) {
        // Enable magic link
        magicLink = true;

        if (onlyMagicLink) {
          // Disable everything else
          signIn = false;
          signUp = false;
          recover = false;
          verify = false;
          multiStep = false; // ignore section

          originalSection = null;
        }
      }

      var _ref17 = _typeof(signIn) === 'object' && signIn || {},
          signInForm = _ref17.form,
          signInFormArguments = _ref17.args,
          oauthSection = _ref17.oauth,
          signInFooter = _ref17.footer,
          signInSwitch = _ref17.switch;

      var _ref18 = _typeof(signUp) === 'object' && signUp || {},
          signUpForm = _ref18.form,
          signUpFormArguments = _ref18.args,
          signUpFooter = _ref18.footer,
          signUpSwitch = _ref18.switch;

      var _ref19 = _typeof(recover) === 'object' && recover || {},
          recoverForm = _ref19.form,
          recoverFormArguments = _ref19.args,
          recoverFooter = _ref19.footer,
          recoverSwitch = _ref19.switch;

      var _ref20 = _typeof(multiStep) === 'object' && multiStep || _typeof(verify) === 'object' && verify || {},
          verifyForm = _ref20.form,
          verifyFormArguments = _ref20.args;

      var _ref21 = _typeof(magicLink) === 'object' && magicLink || {},
          magicLinkForm = _ref21.form,
          magicLinkFormArguments = _ref21.args,
          magicLinkFooter = _ref21.footer,
          magicLinkSwitch = _ref21.switch;

      var _ref22 = switches || {},
          signInSwitchLegacy = _ref22.signIn,
          signUpSwitchLegacy = _ref22.signUp,
          recoverSwitchLegacy = _ref22.recover,
          magicLinkSwitchLegacy = _ref22.magicLink;

      var _ref23 = signInSwitch || signInSwitchLegacy || {},
          signInSwitchInfo = _ref23.info,
          signInSwitchCTA = _ref23.cta,
          signInSwitchBack = _ref23.back;

      var _ref24 = signUpSwitch || signUpSwitchLegacy || {},
          signUpSwitchInfo = _ref24.info,
          signUpSwitchCTA = _ref24.cta;

      var _ref25 = recoverSwitch || recoverSwitchLegacy || {},
          recoverSwitchInfo = _ref25.info,
          recoverSwitchCTA = _ref25.cta;

      var _ref26 = magicLinkSwitch || magicLinkSwitchLegacy || {},
          magicLinkSwitchInfo = _ref26.info,
          magicLinkSwitchCTA = _ref26.cta;

      var oauthProviders = [];

      if (window.booyaConfig && Array.isArray(window.booyaConfig.providers)) {
        oauthProviders = window.booyaConfig.providers.filter(function (provider) {
          return provider !== _this4.providers.names.EMAIL;
        });
      }

      var reactiveSignUpFormArguments = null;

      if (oauthProviders.length) {
        var _ref27 = signUpFormArguments || [],
            _ref28 = _slicedToArray(_ref27, 4),
            signUpTitle = _ref28[0],
            signUpFields = _ref28[1],
            signUpAction = _ref28[2],
            signUpOptions = _ref28[3];

        reactiveSignUpFormArguments = [signUpTitle, signUpFields, signUpAction, _objectSpread(_objectSpread(_objectSpread({}, signUpOptions || {}), signUpOptions && typeof signUpOptions.includeLabels === 'boolean' ? {
          includeLabels: signUpOptions.includeLabels
        } : {}), signUpOptions && typeof signUpOptions.repeatValidation === 'boolean' ? {
          repeatValidation: signUpOptions.repeatValidation
        } : {})];
      }

      var inviteRequired = booyaConfig && booyaConfig.invite && booyaConfig.invite.required || false,
          inviteRequestUrl = booyaConfig && booyaConfig.invite && booyaConfig.invite.requestUrl || '';
      var section = originalSection;

      if (!section) {
        section = signIn && this.sections.SIGNIN || magicLink && this.sections.MAGIC_LINK || !inviteRequired && signUp && this.sections.SIGNUP;
      }

      var signUpSwitchMarkup = signUp && "<div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.SIGNUP, "\">\n                    ").concat(signUpSwitchInfo || this.getFormLabel(this.forms.REGISTER, this.formLabels.SWITCH_PROMPT) || this.translations.getTranslation(this.translations.phrases.DONT_HAVE_ACCOUNT), " <a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(this.sections.SIGNUP, "\">").concat(signUpSwitchCTA || this.getFormLabel(this.forms.REGISTER, this.formLabels.SWITCH_CTA) || this.translations.getTranslation(this.translations.phrases.SIGN_UP), "</a>\n                </div>") || '';
      var signInMarkup = signIn && "<div class=\"".concat(this.selectors.authWidgetSection, " ").concat(this.selectors.authWidgetSection, "-").concat(this.sections.SIGNIN, "\" ").concat(section && section !== this.sections.SIGNIN ? 'style="display: none"' : '', ">\n        ").concat(signInForm || this.renderSignInForm.apply(this, _toConsumableArray(signInFormArguments || [])), "\n        ").concat(oauthSection || oauthProviders.length && "\n                ".concat(this.renderDivider(this.translations.getTranslation(this.translations.phrases.OR)), "\n                ").concat(oauthProviders.map(function (provider) {
        return _this4.renderOAuthButton(provider);
      }).join(''), "\n        ") || '', "\n        ").concat(signInFooter || "\n            ".concat(magicLink && "\n            <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.MAGIC_LINK, "\">\n            ").concat(magicLinkSwitchInfo || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.SWITCH_PROMPT) || '', "<a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(this.sections.MAGIC_LINK, "\">").concat(magicLinkSwitchCTA || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.SWITCH_CTA) || this.translations.getTranslation(this.translations.phrases.SIGN_IN_WITH_MAGIC_LINK), "</a>\n            </div>\n            ") || '', "\n            \n            ").concat(recover && "\n            <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.RECOVER, "\">\n            ").concat(recoverSwitchInfo || this.getFormLabel(this.forms.RECOVER, this.formLabels.SWITCH_PROMPT) || '', "<a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(this.sections.RECOVER, "\">").concat(recoverSwitchCTA || this.getFormLabel(this.forms.RECOVER, this.formLabels.SWITCH_CTA) || this.translations.getTranslation(this.translations.phrases.FORGOT_PASSWORD), "</a>\n            </div>\n            ") || '', "\n            \n            ").concat(!multiStep && "\n                ".concat((!inviteRequired && signUp || inviteRequired && inviteRequestUrl) && this.renderDivider() || '', "\n                \n                ").concat(inviteRequired ? inviteRequestUrl && "\n                <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.INVITE, "\">\n                    ").concat(signUpSwitchInfo || this.getFormLabel(this.forms.REGISTER, this.formLabels.SWITCH_PROMPT) || this.translations.getTranslation(this.translations.phrases.DONT_HAVE_ACCOUNT), " <a href=\"").concat(inviteRequestUrl, "\" class=\"").concat(this.selectors.link, "\">").concat(signUpSwitchCTA || this.translations.getTranslation(this.translations.phrases.REQUEST_INVITE), "</a>\n                </div>\n                ") || '' : signUpSwitchMarkup, "\n            ") || '', "\n        ") || '', "\n    </div>") || ''; // TODO: Add custom switch prompts and ctas for invites

      var signUpMarkup = !inviteRequired && signUp && "\n    <div class=\"".concat(this.selectors.authWidgetSection, " ").concat(this.selectors.authWidgetSection, "-").concat(this.sections.SIGNUP, "\" ").concat(section !== this.sections.SIGNUP ? 'style="display: none"' : '', ">\n        ").concat(signUpForm || this.renderSignUpForm.apply(this, _toConsumableArray(reactiveSignUpFormArguments || signUpFormArguments || [])), "\n        ").concat(oauthSection || oauthProviders.length && "\n                ".concat(this.renderDivider(this.translations.getTranslation(this.translations.phrases.OR)), "\n                ").concat(oauthProviders.map(function (provider) {
        return _this4.renderOAuthButton(provider, {
          action: _this4.translations.getTranslation(_this4.translations.phrases.SIGN_UP_WITH)
        });
      }).join(''), "\n        ") || '', "\n        ").concat(multiStep ? '' : signUpFooter || (magicLink || signIn) && "\n            <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(magicLink ? this.sections.MAGIC_LINK : this.sections.SIGNIN, "\">\n            ").concat(magicLink && (magicLinkSwitchInfo || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.SWITCH_PROMPT)) || signInSwitchInfo || this.getFormLabel(this.forms.LOGIN, this.formLabels.SWITCH_PROMPT) || this.translations.getTranslation(this.translations.phrases.ALREADY_HAVE_ACCOUNT), " <a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(magicLink ? this.sections.MAGIC_LINK : this.sections.SIGNIN, "\">").concat(magicLink && (magicLinkSwitchCTA || this.getFormLabel(this.forms.MAGIC_LINK, this.formLabels.SWITCH_CTA)) || signInSwitchCTA || this.getFormLabel(this.forms.LOGIN, this.formLabels.SWITCH_CTA) || this.translations.getTranslation(this.translations.phrases.SIGN_IN), "</a>\n            </div>\n        ") || '', "\n    </div>\n    ") || '';
      var recoverMarkup = recover && "<div class=\"".concat(this.selectors.authWidgetSection, " ").concat(this.selectors.authWidgetSection, "-").concat(this.sections.RECOVER, "\" ").concat(section !== this.sections.RECOVER ? 'style="display: none"' : '', ">\n        ").concat(recoverForm || this.renderRecoverForm.apply(this, _toConsumableArray(recoverFormArguments || [])), "\n        ").concat(recoverFooter || signIn && "\n            <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.SIGNIN, "\">\n            <a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(this.sections.SIGNIN, "\">").concat(signInSwitchBack || this.getFormLabel(this.forms.LOGIN, this.formLabels.BACK) || this.translations.getTranslation(this.translations.phrases.BACK_TO_SIGN_IN), "</a>\n            </div>\n        "), " \n    </div>") || '';
      var verifyMarkup = verifyForm || this.renderVerifyForm.apply(this, _toConsumableArray(verifyFormArguments || []));
      var magicLinkMarkup = magicLink && "<div class=\"".concat(this.selectors.authWidgetSection, " ").concat(this.selectors.authWidgetSection, "-").concat(this.sections.MAGIC_LINK, "\" ").concat(section && section !== this.sections.MAGIC_LINK ? 'style="display: none"' : '', ">\n        ").concat(magicLinkForm || this.renderMagicLinkForm.apply(this, _toConsumableArray(magicLinkFormArguments || [])), "\n        ").concat(oauthSection || oauthProviders.length && "\n                ".concat(this.renderDivider(this.translations.getTranslation(this.translations.phrases.OR)), "\n                ").concat(oauthProviders.map(function (provider) {
        return _this4.renderOAuthButton(provider);
      }).join(''), "\n        ") || '', "\n        ").concat(onlyMagicLink ? '' : magicLinkFooter || "\n            <div class=\"".concat(this.selectors.authWidgetSectionSwitch, "-wrapper ").concat(this.selectors.authWidgetSectionSwitch, "-wrapper-").concat(this.sections.SIGNIN, "\">\n            ").concat(signInSwitchInfo || '', "<a href=\"#\" class=\"").concat(this.selectors.link, " ").concat(this.selectors.authWidgetSectionSwitch, "-").concat(this.sections.SIGNIN, "\">").concat(signInSwitchCTA || this.getFormLabel(this.forms.LOGIN, this.formLabels.SWITCH_CTA) || this.translations.getTranslation(this.translations.phrases.SIGN_IN_WITH_USERNAME_AND_PASSWORD), "</a>\n            </div>\n            ").concat(signUpSwitchMarkup, "\n        "), "\n    </div>") || '';
      var markup = "\n    <div class=\"".concat(this.selectors.authWidgetsWrapper).concat(className ? " ".concat(className) : '', "\">\n        ").concat(header || '', "\n        ").concat(multiStep && verifyMarkup || "\n            ".concat(signInMarkup || '', "\n            ").concat(signUpMarkup || '', "\n            ").concat(recoverMarkup || '', "\n            ").concat(magicLinkMarkup || '', "\n        "), "\n        ").concat(footer || '', "\n    </div>");

      if (multiStep) {
        // Setup multi step events
        booya.on(booya.events.VERIFY_EMAIL_SUCCESS, function (e) {
          var email = e.email || '';
          booya.widgets.renderModal('', "".concat(signInMarkup).concat(recoverMarkup).concat(magicLinkMarkup), {
            isOpen: true
          });
          var signInWrapper = $(".".concat(_this4.selectors.authWidgetSection, "-").concat(_this4.sections.SIGNIN));
          signInWrapper.show();
          var signInEmailWrapper = signInWrapper.find('[type="email"]');
          signInEmailWrapper.val(email);
          signInEmailWrapper.closest('fieldset').hide();
          $(".".concat(_this4.selectors.authWidgetSection, "-").concat(_this4.sections.RECOVER, " [type=\"email\"]")).val(email);
        });
        booya.on(booya.events.VERIFY_EMAIL_FAILED, function (e) {
          var email = e.email || '';
          booya.widgets.renderModal('', "".concat(signUpMarkup), {
            isOpen: true
          });
          var signUpWrapper = $(".".concat(_this4.selectors.authWidgetSection, "-").concat(_this4.sections.SIGNUP));
          signUpWrapper.show();
          var signUpEmailWrapper = signUpWrapper.find("[type=\"email\"]");
          signUpEmailWrapper.val(email);
          signUpEmailWrapper.closest('fieldset').hide();
        });
      }

      if (modal) {
        var _ref29 = modal || {},
            title = _ref29.title,
            modalClassName = _ref29.className,
            _ref29$isOpen = _ref29.isOpen,
            isOpen = _ref29$isOpen === void 0 ? false : _ref29$isOpen,
            otherOptions = _objectWithoutProperties(_ref29, _excluded11);

        markup = this.renderModal(title, markup, _objectSpread(_objectSpread({}, otherOptions), {}, {
          className: "".concat(this.selectors.modalAuthWidgets).concat(modalClassName ? " ".concat(modalClassName) : ''),
          isOpen: isOpen
        }));
      }

      if (target) {
        $(target).html(markup);

        if (window.booya) {
          window.booya.initUI();
        }

        return;
      }

      return markup;
    }
  }, {
    key: "openAuthWidget",
    value: function openAuthWidget(widget) {
      $(".".concat(this.selectors.authWidgetSection)).hide();
      $(".".concat(this.selectors.authWidgetSection, "-").concat(widget)).show();
    }
  }, {
    key: "renderUserWidget",
    value: function renderUserWidget(target, options) {
      var user = window.user,
          self = this;
      if (!user || !target || $(target).find('.__booya-user-widget').length) return null;
      var markup = "\n<div class=\"__booya-user-widget\">\n    <div>\n        <img src=\"".concat(user.avatar, "\"/> <span class=\"__booya-user-name\">").concat("".concat(user.first_name, " ").concat(user.last_name).trim() || user.email.replace(/@.*/i, ''), "</span>\n    </div>\n    <div class=\"__booya-user-widget-options\">\n        <div class=\"__booya-user-widget-option __booya-edit-profile\">").concat(this.translations.getTranslation(this.translations.phrases.EDIT_PROFILE), "</div>\n        <div class=\"__booya-user-widget-option __booya-logout\">").concat(this.translations.getTranslation(this.translations.phrases.SIGN_OUT), "</div>\n    </div>\n</div>\n        ");
      $(target).append(markup);
      var userWidget = $('.__booya-user-widget');

      var _ref30 = options || {},
          onEditProfile = _ref30.profile,
          logOut = _ref30.logout;

      userWidget.find('.__booya-edit-profile').off('click').click(function () {
        // Edit Profile
        if (onEditProfile) {
          onEditProfile();
        } else {
          booya.trigger(booya.events.EDIT_PROFILE_PROMPT);

          if (!booya.isEventOverridden(booya.events.EDIT_PROFILE_PROMPT)) {
            self.renderModal('', self.renderProfileForm("<h3>".concat(self.translations.getTranslation(self.translations.phrases.EDIT_PROFILE), "</h3>")), {
              isOpen: true
            });
          }
        }
      });
      userWidget.find('.__booya-logout').off('click').click(function () {
        // Logout
        if (logOut) {
          logOut();
        } else {
          booya.logOut();
        }
      });
    }
  }, {
    key: "renderNotice",
    value: function renderNotice(content) {
      var appearance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var className = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : '';
      return "\n<div class=\"".concat(this.selectors.notice).concat(appearance ? " ".concat(this.selectors.notice, "-").concat(appearance || 'info') : '').concat(className ? " ".concat(className) : '', "\">\n    ").concat(content, "\n</div>\n        ");
    }
  }, {
    key: "renderBanner",
    value: function renderBanner(content) {
      var appearance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var isOpen = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var className = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : '';
      var markup = "\n<div class=\"".concat(this.selectors.banner).concat(appearance ? " ".concat(this.selectors.banner, "-").concat(appearance || 'info') : '').concat(className ? " ".concat(className) : '', "\">\n    <div class=\"__booya-banner-content\">\n        <div class=\"__booya-banner-message\">").concat(content, "</div>\n        <div class=\"__booya-banner-close\">\n            <img src=\"https://cdn.jsdelivr.net/npm/@inboundlabs/booya-ui@latest/dist/images/close-white.svg\" width=\"16px\" />\n        </div>\n    </div>\n</div>\n        ");

      if (isOpen) {
        $('body').append(markup);

        if (window.booya) {
          window.booya.initUI();
        }
      }

      return markup;
    }
  }, {
    key: "renderTimedBanner",
    value: function renderTimedBanner(content) {
      var appearance = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'info';
      var delay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 3000;
      var className = "".concat(this.selectors.banner, "-").concat(Date.now());
      this.renderBanner(content, appearance, true, className);
      setTimeout(function () {
        $(".".concat(className)).remove();
      }, delay || 3000);
    }
  }, {
    key: "renderAccountVerifiedBanner",
    value: function renderAccountVerifiedBanner(content) {
      return this.renderBanner(content || '🎉 Account verification complete.', this.banners.SUCCESS, true);
    }
  }]);

  return BooyaWidgets;
}();

var Booya = /*#__PURE__*/function () {
  function Booya() {
    var _this5 = this;

    _classCallCheck(this, Booya);

    _defineProperty(this, "config", window.booyaConfig || {});

    _defineProperty(this, "state", {
      events: []
    });

    _defineProperty(this, "translations", new BooyaTranslations());

    _defineProperty(this, "widgets", new BooyaWidgets());

    _defineProperty(this, "events", {
      // Ready
      READY: 'booya-ready',
      // Register
      REGISTER_SUCCESS: 'booya-register-success',
      REGISTER_FAILED: 'booya-register-failed',
      // Login
      LOGIN_SUCCESS: 'booya-login-success',
      OAUTH_LOGIN_SUCCESS: 'booya-oauth-login-success',
      LOGIN_FAILED: 'booya-login-failed',
      // Identify
      IDENTIFY_SUCCESS: 'booya-identify-success',
      IDENTIFY_FAILED: 'booya-identify-failed',
      // Logout
      LOGOUT_SUCCESS: 'booya-logout-success',
      LOGOUT_FAILED: 'booya-logout-failed',
      // Verify Account
      VERIFY_ACCOUNT_SUCCESS: 'booya-verify-account-success',
      VERIFY_ACCOUNT_FAILED: 'booya-verify-account-success',
      // Validate account
      ACCOUNT_EXISTS_SUCCESS: 'booya-account-exists-success',
      ACCOUNT_EXISTS_FAILED: 'booya-account-exists-failed',
      // Update Profile
      PROFILE_UPDATE_SUCCESS: 'booya-profile-update-success',
      PROFILE_UPDATE_FAILED: 'booya-profile-update-failed',
      // COMPLETE PROFILE PROMPT
      COMPLETE_PROFILE_PROMPT: 'booya-complete-profile-prompt',
      EDIT_PROFILE_PROMPT: 'booya-edit-profile-prompt',
      // RECOVER
      RECOVER_SUCCESS: 'booya-recover-success',
      RECOVER_FAILED: 'booya-recover-failed',
      // RESET
      SET_PASSWORD_SUCCESS: 'booya-set-password-success',
      SET_PASSWORD_FAILED: 'booya-set-password-failed',
      // RESET
      RESET_SUCCESS: 'booya-reset-success',
      RESET_FAILED: 'booya-reset-failed',
      // MAGIC LINK
      MAGIC_LINK_REQUEST_SUCCESS: 'booya-magic-link-request-success',
      MAGIC_LINK_REQUEST_FAILED: 'booya-magic-link-request-failed',
      MAGIC_LINK_VERIFY_SUCCESS: 'booya-magic-link-verify-success',
      MAGIC_LINK_VERIFY_FAILED: 'booya-magic-link-verify-failed',
      // URL REDIRECT
      MEMBER_URL_REDIRECT: 'booya-member-url-redirect',
      GUEST_URL_REDIRECT: 'booya-guest-url-redirect',
      // Keep for legacy integrations
      VERIFY_EMAIL_SUCCESS: 'booya-account-exists-success',
      // Formerly: booya-verify-email-success
      VERIFY_EMAIL_FAILED: 'booya-account-exists-failed' // Formerly: booya-verify-email-failed

    });

    _defineProperty(this, "providers", new BooyaProviders());

    _defineProperty(this, "initUI", function () {
      var self = _this5;
      /* Modals */

      $(".".concat(self.widgets.selectors.modal, " .__booya-close")).off('click').click(function (e) {
        e.preventDefault();
        $(this).closest(".".concat(self.widgets.selectors.modal)).remove();
      });
      /* Auth Widget Section Switches */

      var _loop = function _loop() {
        var section = _arr2[_i3];
        $(".".concat(_this5.widgets.selectors.authWidgetSectionSwitch, "-").concat(section)).off('click').click(function (e) {
          e.preventDefault();
          self.widgets.openAuthWidget(section);
        });
      };

      for (var _i3 = 0, _arr2 = ['signin', 'signup', 'recover', 'magic-link']; _i3 < _arr2.length; _i3++) {
        _loop();
      }
      /* Banners */


      $('.__booya-banner-close').off('click').click(function (e) {
        $(this).closest('.__booya-banner').remove();
      });
      /* Auth Forms */

      $('form.__booya-verify-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        formError.html(formError.attr('data-error'));
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          submitButton.attr('disabled', 'disabled');
          submitButton.html(self.translations.getTranslation(self.translations.phrases.VERIFYING));
          var email = form.find('input[name="email"]').val();
          $.ajax({
            url: self.getAPIEndpointURL("/auth/verify/user"),
            type: "POST",
            data: data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false); //formSuccess.show();
            //formError.hide();
            //formValidationError.hide();

            self.trigger(self.events.ACCOUNT_EXISTS_SUCCESS, {
              email: email,
              form: form.get(0)
            });
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data = $.parseJSON(error.responseText);

              if (_data && _data.reason) {
                switch (_data.reason) {
                  case 'blocked':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_SOMETHING_WRONG_SUPPORT));
                    break;

                  default:
                    break;
                }
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.ACCOUNT_EXISTS_FAILED, {
              email: email,
              form: form.get(0)
            });
          });
        }
      });
      $('form.__booya-signin-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        formError.html(formError.attr('data-error'));
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          submitButton.attr('disabled', 'disabled');
          submitButton.html(self.translations.getTranslation(self.translations.phrases.VERIFYING));
          $.ajax({
            url: self.getAPIEndpointURL("/auth/signin/"),
            type: "POST",
            data: data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);
            formSuccess.show();
            formError.hide();
            formValidationError.hide();
            self.widgets.closeModal(form);

            if (data) {
              if (data.user && data.user.email) {
                /* Identify User in HubSpot */
                self.identifyHubSpotUser(data.user.email);
              }

              if (data.token) {
                localStorage.setItem('booyaToken', data.token);
                self.setCookie('booyaToken', data.token);
              }

              if (data.template_token) {
                self.setCookie('booyaTemplateToken', data.template_token);
              }
            }

            self.trigger(self.events.LOGIN_SUCCESS, {
              form: form.get(0)
            });

            if (!self.isEventOverridden(self.events.LOGIN_SUCCESS)) {
              var memberRedirectUrl = '';

              if (data && data.user && self.config && self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules)) {
                var _iterator = _createForOfIteratorHelper(self.config.advancedMemberUrlConfig.rules),
                    _step;

                try {
                  for (_iterator.s(); !(_step = _iterator.n()).done;) {
                    var rule = _step.value;

                    if (!memberRedirectUrl && rule.name && rule.value && rule.url && data.user[rule.name] === rule.value) {
                      memberRedirectUrl = rule.url;
                    }
                  }
                } catch (err) {
                  _iterator.e(err);
                } finally {
                  _iterator.f();
                }
              }

              var nextUrl = self.getUrlParameter('next');

              if (memberRedirectUrl) {
                self.trigger(self.events.MEMBER_URL_REDIRECT, {
                  user: data && data.user || null,
                  nextUrl: memberRedirectUrl
                });

                if (!self.isEventOverridden(self.events.MEMBER_URL_REDIRECT)) {
                  location.href = memberRedirectUrl;
                }
              } else if (nextUrl) {
                location.href = nextUrl;
              } else if (self.config.memberUrl) {
                location.href = self.config.memberUrl;
              } else {
                location.reload();
              }
            }
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data2 = $.parseJSON(error.responseText);

              if (_data2 && _data2.reason) {
                switch (_data2.reason) {
                  case 'verify':
                    formError.html(self.translations.getTranslation(self.translations.phrases.PLEASE_VERIFY_EMAIL));
                    break;

                  case 'credentials':
                  case 'no_user':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_FIND_ACCOUNT_EMAIL_PASSWORD));
                    break;

                  case 'blocked':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_SIGN_IN_SUPPORT));
                    break;

                  default:
                    break;
                }
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.LOGIN_FAILED, {
              form: form.get(0)
            });
          });
        }
      });
      $('form.__booya-signup-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        formError.html(formError.attr('data-error'));
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          var nextUrl = self.getUrlParameter('next') || location.href;

          if (nextUrl) {
            data = "".concat(data, "&next_url=").concat(nextUrl);
          }

          var lang = self.translations.resolvedLanguage();

          if (lang) {
            data = "".concat(data, "&lang=").concat(lang);
          }

          submitButton.attr('disabled', 'disabled');
          submitButton.html('Saving ...');
          $.ajax({
            url: self.getAPIEndpointURL("/auth/register/"),
            type: "POST",
            data: data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            function completeRegistrationUpdates() {
              // Update Form
              form.get(0).reset();
              submitButton.html(originalSubmitText);
              submitButton.prop('disabled', false); //formSuccess.show();

              formError.hide();
              formValidationError.hide();
              self.widgets.closeModal(form);
              self.widgets.renderBanner(formSuccess.html() || self.translations.getTranslation(self.translations.phrases.ACCOUNT_CREATED_CHECK_INBOX), self.widgets.banners.SUCCESS);
              self.trigger(self.events.REGISTER_SUCCESS, {
                form: form.get(0)
              });
              var signInAfterRegistration = self.config && self.config.signInAfterRegistration || null,
                  newMemberUrl = self.config && self.config.newMemberUrl || null;

              if (signInAfterRegistration) {
                if (data) {
                  if (data.user && data.user.email) {
                    /* Identify User in HubSpot */
                    self.identifyHubSpotUser(data.user.email);
                  }

                  if (data.token) {
                    localStorage.setItem('booyaToken', data.token);
                    self.setCookie('booyaToken', data.token);
                  }

                  if (data.template_token) {
                    self.setCookie('booyaTemplateToken', data.template_token);
                  }
                }

                if (!self.isEventOverridden(self.events.REGISTER_SUCCESS)) {
                  if (newMemberUrl) {
                    location.href = newMemberUrl;
                  } else {
                    var memberRedirectUrl = '';

                    if (data && data.user && self.config && self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules)) {
                      var _iterator2 = _createForOfIteratorHelper(self.config.advancedMemberUrlConfig.rules),
                          _step2;

                      try {
                        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
                          var rule = _step2.value;

                          if (!memberRedirectUrl && rule.name && rule.value && rule.url && data.user[rule.name] === rule.value) {
                            memberRedirectUrl = rule.url;
                          }
                        }
                      } catch (err) {
                        _iterator2.e(err);
                      } finally {
                        _iterator2.f();
                      }
                    }

                    var _nextUrl = self.getUrlParameter('next');

                    if (memberRedirectUrl) {
                      self.trigger(self.events.MEMBER_URL_REDIRECT, {
                        user: data && data.user || null,
                        nextUrl: memberRedirectUrl
                      });

                      if (!self.isEventOverridden(self.events.MEMBER_URL_REDIRECT)) {
                        location.href = memberRedirectUrl;
                      }
                    } else if (_nextUrl) {
                      location.href = _nextUrl;
                    } else if (self.config.memberUrl) {
                      location.href = self.config.memberUrl;
                    } else {
                      location.reload();
                    }
                  }
                }
              }
            } // Send user details to HubSpot


            var hsData = self.processHubSpotProfileData(form.serializeArray());
            var hubtk = self.getCookie('hubspotutk');

            if (data) {
              var registrationFormId = self.config && self.config.hubspot && self.config.hubspot.formIds && self.config.hubspot.formIds.registration || null,
                  email = data.user && data.user.email || '';

              if (self.config.portalID && email && registrationFormId && hubtk) {
                var legalConsentOptions = {};
                var legalLegitimateInterest = form.find('input[name="LEGAL_CONSENT.legitimateInterest"]'),
                    legalCommunications = form.find('input[name="LEGAL_CONSENT.communication"]:checked, input[name="LEGAL_CONSENT.subscription_type"]:checked'),
                    legalProcessing = form.find('input[name="LEGAL_CONSENT.processing"]:checked');

                if (legalLegitimateInterest.val()) {
                  legalConsentOptions.legitimateInterest = {
                    value: true,
                    subscriptionTypeId: parseInt(legalLegitimateInterest.val() || ''),
                    legalBasis: legalLegitimateInterest.attr('data-legal-basis') || '',
                    text: legalLegitimateInterest.attr('data-label')
                  };
                }

                if (legalCommunications.length) {
                  var communicationSubscriptions = [];
                  $.each(legalCommunications, function (idx, item) {
                    var checkbox = $(item);
                    communicationSubscriptions.push({
                      value: true,
                      subscriptionTypeId: parseInt(checkbox.val() || ''),
                      text: checkbox.attr('data-label')
                    });
                  });

                  if (communicationSubscriptions.length) {
                    legalConsentOptions.communications = communicationSubscriptions;
                  }
                }

                if (legalProcessing.length) {
                  legalConsentOptions.processing = {
                    consentToProcess: true,
                    text: legalProcessing.attr('data-label')
                  };
                }

                self.submitHubSpotForm(self.config.portalID, registrationFormId, hubtk, hsData, legalConsentOptions).done(function () {
                  completeRegistrationUpdates();
                }).fail(function (error, data) {
                  completeRegistrationUpdates();
                });
              } else {
                completeRegistrationUpdates();
              }
            } else {
              completeRegistrationUpdates();
            }
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data3 = $.parseJSON(error.responseText);

              if (_data3 && _data3.reason) {
                switch (_data3.reason) {
                  case 'exists':
                    formError.html(self.translations.getTranslation(self.translations.phrases.ACCOUNT_EXISTS));
                    break;

                  case 'blocked':
                    formError.html(self.translations.getTranslation(self.translations.phrases.SORRY_CANT_SIGN_UP_SUPPORT));
                    break;

                  default:
                    break;
                }
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.REGISTER_FAILED, {
              form: form.get(0)
            });
          });
        } else {
          submitButton.html(originalSubmitText);
          submitButton.prop('disabled', false);
          formValidationError.show();
          formError.hide();
          formSuccess.hide();
        }
      });
      $('form.__booya-profile-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        var validationCheck = self.validateForm(form);
        var profileFormId = self.config && self.config.hubspot && self.config.hubspot.formIds && self.config.hubspot.formIds.profile || null,
            email = window.user && window.user.email || '';

        if (validationCheck && self.config.portalID && email && profileFormId) {
          var rawData = form.serializeArray();
          rawData.push({
            name: 'email',
            value: email
          });
          var data = self.processHubSpotProfileData(rawData);
          submitButton.attr('disabled', 'disabled');
          submitButton.html('Saving ...');
          self.submitHubSpotForm(self.config.portalID, profileFormId, self.getCookie('hubspotutk') || null, data).done(function (data) {
            //form.get(0).reset();
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);
            formSuccess.show();
            formError.hide();
            formValidationError.hide();
            var updates = self.processProfileData(form.serializeArray());
            window.user = $.extend(window.user || {}, updates);
            self.trigger(self.events.PROFILE_UPDATE_SUCCESS, {
              form: form.get(0),
              user: window.user,
              updates: updates
            });
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);
            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.PROFILE_UPDATE_FAILED, {
              form: form.get(0)
            });
          });
        } else {
          submitButton.html(originalSubmitText);
          submitButton.prop('disabled', false);
          formValidationError.show();
          formError.hide();
          formSuccess.hide();
        }
      });
      $('form.__booya-recover-account-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          var nextUrl = self.getUrlParameter('next') || location.href;

          if (nextUrl) {
            data = "".concat(data, "&next_url=").concat(nextUrl);
          }

          var lang = self.translations.resolvedLanguage();

          if (lang) {
            data = "".concat(data, "&lang=").concat(lang);
          }

          submitButton.attr('disabled', 'disabled');
          submitButton.html(self.translations.getTranslation(self.translations.phrases.VERIFYING));
          $.ajax({
            url: self.getAPIEndpointURL("/auth/recover/"),
            type: "POST",
            data: data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);
            formSuccess.show();
            formError.hide();
            formValidationError.hide();
            self.trigger(self.events.RECOVER_SUCCESS, {
              form: form.get(0)
            });
          }).fail(function (error, data) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data4 = $.parseJSON(error.responseText);

              if (_data4 && _data4.reason) {
                switch (_data4.reason) {
                  case 'no_user':
                  case 'invalid_email':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_FIND_ACCOUNT_EMAIL));
                    break;

                  case 'blocked':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_ACCOUNT_RECOVERY_SUPPORT));
                    break;

                  default:
                    break;
                }
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.RECOVER_FAILED, {
              form: form.get(0)
            });
          });
        }
      });
      $('form.__booya-set-password-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        formError.html(formError.attr('data-error'));
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          submitButton.attr('disabled', 'disabled');
          submitButton.html('Saving ...');
          $.ajax({
            url: self.getAPIEndpointURL("/auth/set-password/"),
            type: "POST",
            data: 'token=' + encodeURIComponent(window.invitationToken) + '&' + data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            window.invitationToken = null;
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false); //formSuccess.show();

            formError.hide();
            formValidationError.hide();
            history.replaceState(null, "", location.pathname + self.getQueryStringWithoutAuthParams());
            self.widgets.closeModal(form);
            self.widgets.renderTimedBanner(formSuccess.html() || self.translations.getTranslation(self.translations.phrases.PASSWORD_SET_SUCCESSFULLY), self.widgets.banners.SUCCESS);
            self.trigger(self.events.SET_PASSWORD_SUCCESS, {
              form: form.get(0)
            });
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data5 = $.parseJSON(error.responseText);

              if (_data5 && ['invalid_token', 'no_user'].indexOf(_data5.reason) > -1) {
                formError.html(self.translations.getTranslation(self.translations.phrases.THIS_LINK_IS_INVALID_EXPIRED_SUPPORT));
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.SET_PASSWORD_FAILED, {
              form: form.get(0)
            });
          });
        }
      });
      $('form.__booya-reset-password-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        formError.html(formError.attr('data-error'));
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          submitButton.attr('disabled', 'disabled');
          submitButton.html('Saving ...');
          $.ajax({
            url: self.getAPIEndpointURL("/auth/change-password/"),
            type: "POST",
            data: 'token=' + encodeURIComponent(window.recoveryToken) + '&' + data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            window.recoveryToken = null;
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false); //formSuccess.show();

            formError.hide();
            formValidationError.hide();
            history.replaceState(null, "", location.pathname + self.getQueryStringWithoutAuthParams());
            self.widgets.closeModal(form);
            self.widgets.renderTimedBanner(formSuccess.html() || self.translations.getTranslation(self.translations.phrases.PASSWORD_UPDATED_SUCCESSFULLY), self.widgets.banners.SUCCESS);
            self.trigger(self.events.RESET_SUCCESS, {
              form: form.get(0)
            });
          }).fail(function (error) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data6 = $.parseJSON(error.responseText);

              if (_data6 && ['invalid_token', 'no_user'].indexOf(_data6.reason) > -1) {
                formError.html(self.translations.getTranslation(self.translations.phrases.THIS_LINK_IS_INVALID_EXPIRED_GENERATE, {
                  link_open: "<a href='#' class='__booya-modal-switch' data-modal='__booya-modal-recover-account'>",
                  link_close: "</a>"
                }));
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.RESET_FAILED, {
              form: form.get(0)
            });
          });
        }
      });
      $('form.__booya-magic-link-form').find('button[type="submit"]').off('click').click(function (e) {
        e.preventDefault();
        var form = $(this).parents('form');
        var submitButton = $(this),
            formSuccess = form.find('.form-success'),
            formError = form.find('.form-error'),
            formValidationError = form.find('.form-validation-error'),
            originalSubmitText = submitButton.html();
        formSuccess.hide();
        formError.hide();
        formValidationError.hide();
        var validationCheck = self.validateForm(form);

        if (validationCheck) {
          var data = form.serialize();
          data = data + '&next_url=' + location.href;
          var lang = self.translations.resolvedLanguage();

          if (lang) {
            data = "".concat(data, "&lang=").concat(lang);
          }

          if (self && self.config && self.config.onlyMagicLink) {
            data = "".concat(data, "&register=true");
          }

          submitButton.attr('disabled', 'disabled');
          submitButton.html(self.translations.getTranslation(self.translations.phrases.VERIFYING));
          $.ajax({
            url: self.getAPIEndpointURL("/auth/magic-link/request/"),
            type: "POST",
            data: data,
            dataType: 'json',
            xhrFields: {
              withCredentials: true
            }
          }).done(function (data) {
            form.get(0).reset();
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);
            formSuccess.show();
            formError.hide();
            formValidationError.hide();
            self.trigger(self.events.MAGIC_LINK_REQUEST_SUCCESS, {
              form: form.get(0)
            });
          }).fail(function (error, data) {
            submitButton.html(originalSubmitText);
            submitButton.prop('disabled', false);

            if (error && error.responseText) {
              var _data7 = $.parseJSON(error.responseText);

              if (_data7 && _data7.reason) {
                switch (_data7.reason) {
                  case 'blocked':
                    formError.html(self.translations.getTranslation(self.translations.phrases.OOPS_SOMETHING_WRONG_SUPPORT));
                    break;

                  default:
                    break;
                }
              }
            }

            formError.show();
            formSuccess.hide();
            formValidationError.hide();
            self.trigger(self.events.MAGIC_LINK_REQUEST_FAILED, {
              form: form.get(0)
            });
          });
        }
      });
    });

    // Update window reference
    window.booya = this;
    this.isInitialized = false;
    this.isReady = false; // For GDPR compliance, delete legacy booyaHubspotutk cookie if it exists

    if (this.getCookie('booyaHubspotutk')) {
      this.deleteCookie('booyaHubspotutk');
    } // Backwards compatibility


    this.submitHubSpotVerificationForm = this.identifyHubSpotUser;
    var hasBrixModules = $('#brix-booya-signin').length || $('#brix-booya-user-widget').length || $('.brix-dashboard-object-wrapper').length;

    if (window.booyaConfig.__product !== 'brix' && hasBrixModules) {
      window.booyaConfig.__product = 'brix';
      window.booyaConfig.__platform = 'hubspot';
    }

    this.setConfig(_objectSpread(_objectSpread({
      portalID: '',
      appID: '',
      memberUrl: '',
      guestUrl: '',
      recoverUrl: '',
      resetUrl: '',
      __mode: 'live'
    }, window.booyaConfig || {}), {}, {
      language: window.booyaConfig && window.booyaConfig.language || this.translations.detectLanguage() || this.translations.languages.ENGLISH
    }));

    var _self = this;

    function completeInitialization() {
      var isBrix = _self.config.__product === 'brix';

      var initEditorBannerLinks = function initEditorBannerLinks() {
        if (window.hsInEditor) {
          $('.__booya-banner a').off('click').click(function (e) {
            var url = e.target.href;

            if (url) {
              e.preventDefault();
              window.open(e.target.href, '_blank');
            }
          });
        }
      };

      if (typeof _self.config.__setup === 'boolean' && !_self.config.__setup && window.hsInEditor && (_self.config.__product !== 'brix' || hasBrixModules)) {
        _self.widgets.renderBanner("Some modules on this page require <a href=\"https://booya.io/\" target=\"_blank\">Booya</a> to work. | <a href=\"https://go.booya.io\" target=\"_blank\">Configure</a> | <a href=\"https://support.inboundlabs.co/en/brix-get-started-with-booya\" target=\"_blank\">Help</a>", _self.widgets.banners.WARN);

        initEditorBannerLinks();
      }

      if (isBrix) {
        var mode = window.booyaConfig && window.booyaConfig.__mode || 'live',
            version = window.booyaConfig && window.booyaConfig.__version || 'latest';
        var dateNow = new Date(),
            cacheTag = "".concat(dateNow.getFullYear(), "-").concat(dateNow.getMonth(), "-").concat(dateNow.getDate(), "@").concat(dateNow.getHours());
        var head = $('head');
        var link = document.createElement('link');
        link.rel = 'stylesheet';
        link.href = mode === 'local-assets' ? '../dist/css/booya-brix.css' : "https://cdn.jsdelivr.net/npm/@inboundlabs/booya-ui@".concat(version, "/dist/css/booya-brix.min.css?ctag=").concat(encodeURIComponent(cacheTag));
        var title = head.find('title');

        if (title.length) {
          title.after(link);
        } else {
          head.prepend(link);
        }

        var hubspotScopes = _self.config.hubspot && _self.config.hubspot.scopes || [];

        if (window.hsInEditor && _self.config.__setup && !hubspotScopes.includes('tickets') && /name: "ticket",/.test($('.brix-dashboard-object-wrapper').next('script').html())) {
          var matches = /*#__PURE__*/_wrapRegExp(/https?:\/\/preview.hs\x2Dsites.com\/_hcms\/preview\/content\/([0-9]+).*portalId=([0-9]+)/i, {
            page_id: 1,
            portal_id: 2
          }).exec(window.location.href);

          var editorUrl = null;

          if (matches && matches.groups && matches.groups.page_id && matches.groups.portal_id) {
            editorUrl = "https://app.hubspot.com/content/".concat(matches.groups.portal_id, "/edit/").concat(matches.groups.page_id, "/content");
          }

          _self.widgets.renderBanner("Some modules on this page require <a href=\"https://booya.io/\" target=\"_blank\">Booya</a> to have access to HubSpot tickets and/or custom objects to work. | <a href=\"https://go.booya.io/connect/hubspot/add?app_id=".concat(encodeURIComponent(_self.config.appID), "&scopes=").concat(encodeURIComponent('tickets content hubdb crm.objects.custom.read e-commerce'), "&redirect_url=").concat(encodeURIComponent(editorUrl || window.location.href), "\" target=\"_blank\">Configure</a> | <a href=\"https://support.inboundlabs.co/en/brix-get-started-with-booya\" target=\"_blank\">Help</a>"), _self.widgets.banners.WARN);

          initEditorBannerLinks();
        }
      }

      $(document).ready(function () {
        if (_self.config.portalID && _self.config.appID) {
          // Set instance state to ready
          _self.isReady = true; // Trigger ready event

          _self.trigger(_self.events.READY); // Initialize Booya


          _self.init();
        }
      });
    }

    if (typeof _self.config.__setup === 'boolean' && _self.config.context && _self.config.context.domain) {
      completeInitialization();
    } else if (_self.config.appID || _self.config.portalID) {
      $.ajax({
        url: "".concat(_self.config.appID ? _self.getAPIEndpointURL('/config') : "".concat(_self.getAPIBaseURL(), "/config/").concat(_self.config.portalID), "?version=").concat(window.booyaConfig.__version || '', "&platform=").concat(window.booyaConfig.__platform || '', "&product=").concat(window.booyaConfig.__product || '', "&url=").concat(encodeURIComponent(location.href)),
        type: "GET",
        dataType: 'json',
        xhrFields: {
          withCredentials: true
        }
      }).done(function (data) {
        _self.setConfig(_objectSpread(_objectSpread({}, data || {}), {}, {
          __setup: true
        }));

        completeInitialization();
      }).fail(function (error) {
        if (error && error.responseText) {
          var data = $.parseJSON(error.responseText);

          if (data) {
            if (data.reason === 'not_setup') {
              _self.setConfig({
                __setup: false
              });
            }

            if (data.__version) {
              _self.setConfig({
                __version: data.__version
              });
            }
          }
        }

        completeInitialization();
      });
    }
  }

  _createClass(Booya, [{
    key: "setConfig",
    value: function setConfig(config) {
      this.config = _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, window.booyaConfig || {}), this.config || {}), config || {}), window.booyaConfig && window.booyaConfig.overrides || {}), this.config && this.config.overrides || {}), config && config.overrides || {}); // Set API Root

      this.config.apiRoot = this.getAPIEndpointURL('');
      this.widgets = new BooyaWidgets();
      this.providers = new BooyaProviders();
      window.booyaConfig = this.config;
    }
  }, {
    key: "overrideConfig",
    value: function overrideConfig(config) {
      this.setConfig({
        overrides: config
      });
    }
  }, {
    key: "setCookie",
    value: function setCookie(cookieName, cookieValue, expireDays, domain) {
      var expiryDate = new Date();
      expiryDate.setTime(expiryDate.getTime() + expireDays * 24 * 60 * 60 * 1000);
      document.cookie = "".concat(cookieName, "=").concat(cookieValue, ";").concat(domain ? "Domain=".concat(domain, ";") : '', "Path=/;expires=").concat(expiryDate.toUTCString(), ";");
    }
  }, {
    key: "deleteCookie",
    value: function deleteCookie(cookieName, domain) {
      document.cookie = "".concat(cookieName, "=;").concat(domain ? "Domain=".concat(domain, ";") : '', "Path=/;expires=Thu, 01 Jan 1970 00:00:00 GMT;");
    }
  }, {
    key: "getCookie",
    value: function getCookie(cookieName) {
      var name = cookieName + "=";
      var decodedCookie = decodeURIComponent(document.cookie);
      var ca = decodedCookie.split(';');

      for (var i = 0; i < ca.length; i++) {
        var c = ca[i];

        while (c.charAt(0) === ' ') {
          c = c.substring(1);
        }

        if (c.indexOf(name) === 0) {
          return c.substring(name.length, c.length);
        }
      }

      return "";
    }
  }, {
    key: "getRootDomain",
    value: function getRootDomain() {
      var domain = location.hostname;

      if (domain === 'localhost' || /\d+\.\d+\.\d+\.\d+/i.test(domain)) {
        // Not a domain
        return null;
      } else if (this.config.context && this.config.context.domain) {
        return this.config.context.domain;
      } else {
        var parts = domain.split('.');
        var maxIdx = parts.length - 1;
        var isSubdomainLevel = parts.length >= 3 && (parts[maxIdx] + parts[maxIdx - 1]).length <= 5;
        return parts.splice(isSubdomainLevel ? -3 : -2).join('.');
      }
    }
  }, {
    key: "getUrlParameter",
    value: function getUrlParameter(name) {
      name = name.replace(/[\[]/, '\\[').replace(/[\]]/, '\\]');
      var regex = new RegExp('[\\?&]' + name + '=([^&#]*)');
      var results = regex.exec(location.search);
      return results === null ? '' : decodeURIComponent(results[1].replace(/\+/g, ' '));
    }
  }, {
    key: "getQueryStringWithoutAuthParams",
    value: function getQueryStringWithoutAuthParams() {
      var qParams = location.search || '';

      if (qParams) {
        for (var _i4 = 0, _arr3 = ['code', 'invitation_key', 'recovery_key', 'verification_key', 'magic_link_key']; _i4 < _arr3.length; _i4++) {
          var key = _arr3[_i4];
          var value = this.getUrlParameter(key);

          if (value) {
            for (var _i5 = 0, _arr4 = ["".concat(key, "=").concat(encodeURIComponent(value)), "".concat(key, "=").concat(value)]; _i5 < _arr4.length; _i5++) {
              var param = _arr4[_i5];
              qParams = qParams.replace("&".concat(param), '').replace(param, '');
            }
          }
        }
      }

      return qParams;
    }
  }, {
    key: "getAPIBaseURL",
    value: function getAPIBaseURL() {
      return this.config.__mode === 'development' ? 'http://localhost:5000' : 'https://auth.booya.io';
    }
  }, {
    key: "getAPIEndpointURL",
    value: function getAPIEndpointURL(path) {
      return this.getAPIBaseURL() + (this.config.appID ? "/".concat(this.config.appID) : '') + (path || '');
    }
  }, {
    key: "trigger",
    value: function trigger(eventName, data) {
      var self = this;

      if (eventName === self.events.IDENTIFY_FAILED) {
        if (self.config.guestUrl) {
          var parseComparableUrl = function parseComparableUrl(url) {
            return (url || '').replace(/^https?:\/\//i, '').replace(/\?.*$/i, '').replace(/#.*$/i, '');
          };

          var guestUrl = self.config.guestUrl,
              comparableCurrentLocation = parseComparableUrl(window.location.href),
              comparableRedirectableUrls = [self.config.memberUrl].concat(_toConsumableArray((self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules) ? self.config.advancedMemberUrlConfig.rules : []).map(function (i) {
            return i.url;
          }))).filter(function (i) {
            return i;
          }).map(function (i) {
            return parseComparableUrl(i);
          });

          if (comparableRedirectableUrls.includes(comparableCurrentLocation) && parseComparableUrl(guestUrl) !== comparableCurrentLocation) {
            var guestRedirectUrl = "".concat(guestUrl).concat(location.search ? "".concat(/\?/i.test(guestUrl) ? '&' : '?').concat((location.search || '').replace('?', '')) : '');
            self.trigger(self.events.GUEST_URL_REDIRECT, {
              nextUrl: guestRedirectUrl
            });

            if (!self.isEventOverridden(self.events.GUEST_URL_REDIRECT)) {
              window.location.href = guestRedirectUrl;
              return;
            }
          }
        }
      }

      $.event.trigger(_objectSpread(_objectSpread({
        type: eventName
      }, data || {}), {}, {
        time: new Date()
      }));
    }
  }, {
    key: "isEventOverridden",
    value: function isEventOverridden(eventName) {
      return (this.state.events || []).includes(eventName);
    }
  }, {
    key: "validateForm",
    value: function validateForm(form) {
      var self = this;
      $('.error').remove();
      var emptyMessage = this.translations.getTranslation(this.translations.phrases.PLEASE_COMPLETE_FIELD),
          invalidURLMessage = this.translations.getTranslation(this.translations.phrases.PLEASE_ENTER_VALID_URL),
          invalidVideoURLMessage = "Please enter a Youtube, Vimeo, Wistia or Vidyard URL.",
          invalidHubSpotPartnerURLMessage = "Please enter a HubSpot Partner Directory profile URL.",
          invalidEmailMessage = this.translations.getTranslation(this.translations.phrases.PLEASE_ENTER_VALID_EMAIL),
          fileEmpty = "Please select a file.";

      function isUrlValid(url) {
        return /^(?:(?:https?|ftp):\/\/)?(?:(?!(?:10|127)(?:\.\d{1,3}){3})(?!(?:169\.254|192\.168)(?:\.\d{1,3}){2})(?!172\.(?:1[6-9]|2\d|3[0-1])(?:\.\d{1,3}){2})(?:[1-9]\d?|1\d\d|2[01]\d|22[0-3])(?:\.(?:1?\d{1,2}|2[0-4]\d|25[0-5])){2}(?:\.(?:[1-9]\d?|1\d\d|2[0-4]\d|25[0-4]))|(?:(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)(?:\.(?:[a-z\u00a1-\uffff0-9]-*)*[a-z\u00a1-\uffff0-9]+)*(?:\.(?:[a-z\u00a1-\uffff]{2,})))(?::\d{2,5})?(?:\/\S*)?$/i.test(url);
      }

      function isEmailValid(email) {
        return /^\w+([^@\s]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,})+$/.test(email);
      }

      function isVideoUrlValid(url) {
        return /https?:\/\/(.*youtube\.com\/watch.*|.*\.youtube\.com\/v\/.*|youtu\.be\/.*|.*\.youtube\.com\/user\/.*|.*\.youtube\.com\/.*#.*\/.*|m\.youtube\.com\/watch.*|m\.youtube\.com\/index.*|.*\.youtube\.com\/profile.*|.*\.youtube\.com\/view_play_list.*|.*\.youtube\.com\/playlist.*|www\.youtube\.com\/embed\/.*|youtube\.com\/gif.*|www\.youtube\.com\/gif.*|www\.youtube\.com\/attribution_link.*|youtube\.com\/attribution_link.*|youtube\.ca\/.*|youtube\.jp\/.*|youtube\.com\.br\/.*|youtube\.co\.uk\/.*|youtube\.nl\/.*|youtube\.pl\/.*|youtube\.es\/.*|youtube\.ie\/.*|it\.youtube\.com\/.*|youtube\.fr\/.*|www\.vimeo\.com\/groups\/.*\/videos\/.*|www\.vimeo\.com\/.*|vimeo\.com\/groups\/.*\/videos\/.*|vimeo\.com\/.*|vimeo\.com\/m\/#\/.*|player\.vimeo\.com\/.*|app\.wistia\.com\/embed\/medias\/.*|wistia\.com\/.*|.*\.wistia\.com\/.*|.*\.wi\.st\/.*|wi\.st\/.*|.*vidyard\.com\/.*)/i.test(url);
      }

      function isHubSpotPartnerUrlValid(url) {
        return /https?:\/\/www\.hubspot\.com\/agencies\/.+/i.test(url);
      } // Clear all errors


      form.find('fieldset .error').remove();
      form.find('fieldset').removeClass('has-error');
      form.find('[required] input[type="text"], [required] input[type="password"], [required] textarea, [required] select').each(function () {
        var textValue = $(this).val(),
            characterLimit = parseInt($(this).data('character-limit')),
            wordLimit = parseInt($(this).data('word-limit')),
            limitError = '';

        if (characterLimit && textValue.split().length > characterLimit) {
          limitError = self.translations.getTranslation(characterLimit === 1 ? self.translations.phrases.THIS_MORE_CHARACTER : self.translations.phrases.THIS_MORE_CHARACTERS, {
            number: characterLimit
          });
        } else if (wordLimit && textValue.split(' ').length > wordLimit) {
          limitError = self.translations.getTranslation(wordLimit === 1 ? self.translations.phrases.THIS_MORE_WORD : self.translations.phrases.THIS_MORE_WORDS, {
            number: wordLimit
          });
        }

        if (!textValue) {
          $(this).closest('fieldset').append('<div class="error">' + (limitError || emptyMessage) + '</div>');
          $(this).closest('fieldset').addClass('has-error');
        } else if ($(this).attr('type') === 'password' && (form.attr('name') === 'signup' || $(this).attr('name') === 'new_password' || $(this).attr('name') === 'confirm_password')) {
          if ($(this).attr('name') === 'confirm_password') {
            if (textValue !== form.find('[type="password"]:not([name="confirm_password"])').val()) {
              $(this).closest('fieldset').append('<div class="error">Passwords don\'t match</div>');
              $(this).closest('fieldset').addClass('has-error');
            }
          } else {
            var passwordErrorMsgs = [];
            var passwordLengthLimit = parseInt(booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.length) || 6,
                passwordDigits = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.digits || false,
                passwordLowercase = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.lowercase || false,
                passwordUppercase = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.uppercase || false,
                passwordSpecial = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.special || false,
                passwordNoProfileInfo = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.noProfileInfo || false,
                passwordBlacklist = booyaConfig && booyaConfig.passwordSettings && booyaConfig.passwordSettings.blacklist || '';

            if (textValue.split('').length < passwordLengthLimit) {
              passwordErrorMsgs.push(self.translations.getTranslation(passwordLengthLimit === 1 ? self.translations.phrases.PASSWORD_AT_LEAST_CHARACTER : self.translations.phrases.PASSWORD_AT_LEAST_CHARACTERS, {
                number: passwordLengthLimit
              }));
            }

            for (var _i6 = 0, _arr5 = [[passwordDigits, /\d/i, self.translations.getTranslation(self.translations.phrases.PASSWORD_MUST_CONTAIN_DIGIT)], [passwordLowercase, /[a-z]/, self.translations.getTranslation(self.translations.phrases.PASSWORD_MUST_CONTAIN_LOWERCASE_LETTER)], [passwordUppercase, /[A-Z]/, self.translations.getTranslation(self.translations.phrases.PASSWORD_MUST_CONTAIN_UPPERCASE_LETTER)], [passwordSpecial, /[^A-Za-z0-9]/i, self.translations.getTranslation(self.translations.phrases.PASSWORD_MUST_CONTAIN_SPECIAL_CHARACTERS)]]; _i6 < _arr5.length; _i6++) {
              var _arr5$_i = _slicedToArray(_arr5[_i6], 3),
                  isEnabled = _arr5$_i[0],
                  regex = _arr5$_i[1],
                  errorMsg = _arr5$_i[2];

              if (isEnabled && !regex.test(textValue)) {
                passwordErrorMsgs.push(errorMsg);
              }
            }

            if (passwordNoProfileInfo) {
              var profileInfo = [];

              var _iterator3 = _createForOfIteratorHelper([form.find('input[name="first_name"]').val(), form.find('input[name="last_name"]').val(), (form.find('input[name="email"]').val() || '').replace(/@.*/i, ''), window.user && window.user.first_name || '', window.user && window.user.last_name || '', (window.user && window.user.email || '').replace(/@.*/i, '')].filter(function (i) {
                return (i || '').trim();
              })),
                  _step3;

              try {
                for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
                  var profileValue = _step3.value;
                  profileInfo = profileInfo.concat(profileValue.split(/\s/).join('|'));
                }
              } catch (err) {
                _iterator3.e(err);
              } finally {
                _iterator3.f();
              }

              var _iterator4 = _createForOfIteratorHelper(profileInfo),
                  _step4;

              try {
                for (_iterator4.s(); !(_step4 = _iterator4.n()).done;) {
                  var profileWord = _step4.value;

                  if (new RegExp(profileWord, 'i').test(textValue)) {
                    passwordErrorMsgs.push(self.translations.getTranslation(self.translations.phrases.PASSWORD_CANT_CONTAIN_WORD, {
                      word: profileWord
                    }));
                  }
                }
              } catch (err) {
                _iterator4.e(err);
              } finally {
                _iterator4.f();
              }
            }

            if (passwordBlacklist) {
              var blacklistWords = (passwordBlacklist || '').split(',').filter(function (i) {
                return (i || '').trim();
              });

              var _iterator5 = _createForOfIteratorHelper(blacklistWords),
                  _step5;

              try {
                for (_iterator5.s(); !(_step5 = _iterator5.n()).done;) {
                  var badWord = _step5.value;

                  if (new RegExp(badWord, 'i').test(textValue)) {
                    passwordErrorMsgs.push(self.translations.getTranslation(self.translations.phrases.PASSWORD_CANT_CONTAIN_WORD, {
                      word: badWord
                    }));
                  }
                }
              } catch (err) {
                _iterator5.e(err);
              } finally {
                _iterator5.f();
              }
            }

            if (passwordErrorMsgs.length) {
              $(this).closest('fieldset').append('<div class="error ' + (passwordErrorMsgs.length > 1 ? 'multiple-errors' : '') + '">' + (passwordErrorMsgs.length === 1 ? passwordErrorMsgs[0] : '<ul>' + passwordErrorMsgs.map(function (msg) {
                return "<li>".concat(msg, "</li>");
              }).join('') + '</ul>') + '</div>');
              $(this).closest('fieldset').addClass('has-error');
            }
          }
        }
      });
      form.find('input[type="url"]').each(function () {
        var urlValue = $(this).val(),
            isRequired = $(this).parents('[required]').length,
            inputName = $(this).attr('name');

        if (!urlValue && isRequired) {
          $(this).closest('fieldset').append('<div class="error">' + emptyMessage + '</div>');
          $(this).closest('fieldset').addClass('has-error');
        } else if (urlValue) {
          if (!isUrlValid(urlValue)) {
            $(this).closest('fieldset').append('<div class="error">' + invalidURLMessage + '</div>');
            $(this).closest('fieldset').addClass('has-error');
          } else if (inputName === 'video' && !isVideoUrlValid(urlValue)) {
            $(this).closest('fieldset').append('<div class="error">' + invalidVideoURLMessage + '</div>');
            $(this).closest('fieldset').addClass('has-error');
          } else if (inputName === 'partner_directory_url' && !isHubSpotPartnerUrlValid(urlValue)) {
            $(this).closest('fieldset').append('<div class="error">' + invalidHubSpotPartnerURLMessage + '</div>');
            $(this).closest('fieldset').addClass('has-error');
          }
        }
      });
      form.find('[required] input[type="email"]').each(function () {
        var emailValue = $(this).val();

        if (!emailValue) {
          $(this).closest('fieldset').append('<div class="error">' + emptyMessage + '</div>');
          $(this).closest('fieldset').addClass('has-error');
        } else if (!isEmailValid(emailValue)) {
          $(this).closest('fieldset').append('<div class="error">' + invalidEmailMessage + '</div>');
          $(this).closest('fieldset').addClass('has-error');
        }
      });
      form.find('[required] input[type="file"]').each(function () {
        var fileValue = $(this).val(),
            customErrorMsg = $(this).data('error-msg');

        if (!fileValue || customErrorMsg) {
          $(this).closest('fieldset').append('<div class="error">' + (customErrorMsg || fileEmpty) + '</div>');
          $(this).closest('fieldset').addClass('has-error');
        }
      });
      form.find('[required] input[type="checkbox"]').each(function () {
        if (!$(this).prop('checked')) {
          $(this).closest('fieldset').append("<div class=\"error\">".concat(emptyMessage, "</div>"));
          $(this).closest('fieldset').addClass('has-error');
        }
      });
      return !(form.find('fieldset .error').length >= 1);
    }
  }, {
    key: "submitHubSpotForm",
    value: function submitHubSpotForm(portalId, formId, utk, data) {
      var legalConsent = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      var hsData = {
        fields: data
      };

      if (utk) {
        hsData.context = {
          hutk: utk
        };
      }

      if (legalConsent) {
        var parsedLegalConsentOptions = {};

        if (legalConsent.legitimateInterest && _typeof(legalConsent.legitimateInterest) === 'object') {
          parsedLegalConsentOptions.legitimateInterest = legalConsent.legitimateInterest;
        }

        var communicationsChoices = [];

        if (legalConsent.communications) {
          if (Array.isArray(legalConsent.communications)) {
            communicationsChoices = legalConsent.communications;
          } else if (_typeof(legalConsent.communications) && legalConsent.subscriptionTypeId) {
            communicationsChoices.push({
              value: true,
              subscriptionTypeId: legalConsent.subscriptionTypeId,
              text: legalConsent.communicationsText
            });
          }
        }

        var processingConsent = null;

        if (legalConsent.processing && _typeof(legalConsent.processing) === 'object') {
          processingConsent = legalConsent.processing;
        } else if (legalConsent.process) {
          processingConsent = {
            consentToProcess: true,
            text: legalConsent.processText
          };
        }

        var hasCommunications = communicationsChoices && communicationsChoices.length;

        if (hasCommunications || processingConsent) {
          parsedLegalConsentOptions.consent = {};

          if (hasCommunications) {
            parsedLegalConsentOptions.consent.communications = communicationsChoices;
          }

          if (processingConsent) {
            parsedLegalConsentOptions.consent = _objectSpread(_objectSpread({}, hsData.legalConsentOptions.consent), processingConsent);
          }
        }

        if (Object.keys(parsedLegalConsentOptions).length > 0) {
          hsData.legalConsentOptions = parsedLegalConsentOptions;
        }
      }

      return $.ajax({
        url: 'https://api.hsforms.com/submissions/v3/integration/submit/' + portalId + '/' + formId,
        type: "POST",
        data: JSON.stringify(hsData),
        contentType: 'application/json',
        processData: false,
        dataType: 'json'
      });
    }
  }, {
    key: "identifyHubSpotUser",
    value: function identifyHubSpotUser(email, callback) {
      var self = this,
          utk = self.getCookie('hubspotutk'),
          verificationFormId = self.config && self.config.hubspot && self.config.hubspot.formIds && self.config.hubspot.formIds.verification || null,
          cleanedCallback = typeof callback === 'function' ? callback : function () {};

      var refreshIdentity = function refreshIdentity() {
        var resetCookies = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : false;

        if (resetCookies) {
          // HS set cookies on root domain
          var rootDomain = self.getRootDomain();

          if (rootDomain) {
            rootDomain = ".".concat(rootDomain);
          }

          self.deleteCookie('hubspotutk', rootDomain); // Need to delete other hubspot session cookies otherwise same utk will be regenerated
          // https://community.hubspot.com/t5/APIs-Integrations/Reset-identity-via-js-api/td-p/225326
          // https://knowledge.hubspot.com/reports/what-cookies-does-hubspot-set-in-a-visitor-s-browser

          self.deleteCookie('__hstc', rootDomain);
        }

        if (self.config.portalID) {
          // Submit form to identify user with hubspot
          self.submitHubSpotForm(self.config.portalID, verificationFormId, resetCookies ? null : utk, [{
            name: 'email',
            value: email
          }]).done(function (data) {
            cleanedCallback(true);
          }).fail(function (error) {
            cleanedCallback(false);
          });
        } else {
          cleanedCallback(false);
        }
      };

      if (utk) {
        $.ajax({
          url: self.getAPIEndpointURL('/auth/hubspot/contact/utk/verify?utk=' + encodeURIComponent(utk)),
          type: "GET",
          dataType: 'json',
          xhrFields: {
            withCredentials: true
          }
        }).done(function (data) {
          var isValid = data && data.isValid,
              isContact = data && data.isContact;

          if (isValid) {
            // user token is valid, no need to refresh
            cleanedCallback(false);
          } else {
            refreshIdentity(isContact);
          }
        }).fail(function (error) {
          refreshIdentity(false);
        });
      } else {
        refreshIdentity(false);
      }
    }
  }, {
    key: "logOut",
    value: function logOut() {
      var self = this,
          authToken = localStorage.getItem('booyaToken');
      $.ajax(_objectSpread(_objectSpread({
        url: self.getAPIEndpointURL('/auth/logout'),
        type: "POST"
      }, authToken ? {
        data: "token=".concat(authToken)
      } : {}), {}, {
        dataType: 'json',
        xhrFields: {
          withCredentials: true
        }
      })).done(function (data) {
        window.user = null;
        localStorage.removeItem('booyaToken');
        self.setCookie('booyaToken', '');
        self.setCookie('booyaTemplateToken', '');
        self.trigger(self.events.LOGOUT_SUCCESS);

        if (!self.isEventOverridden(self.events.LOGOUT_SUCCESS)) {
          if (self.config.guestUrl) {
            location.href = self.config.guestUrl;
          } else {
            location.reload();
          }
        }
      }).fail(function (error) {
        self.trigger(self.events.LOGOUT_FAILED);
      });
    }
  }, {
    key: "verifyUser",
    value: function verifyUser() {
      var self = this,
          authToken = localStorage.getItem('booyaToken'),
          code = this.getUrlParameter('code'),
          verificationKey = self.getUrlParameter('verification_key'),
          magicLinkKey = self.getUrlParameter('magic_link_key'),
          isVerified = localStorage.getItem('booyaVerified');
      var token = code && /^btc-.+/.test(code) ? code : authToken;

      var showAndClearVerified = function showAndClearVerified() {
        self.widgets.renderAccountVerifiedBanner();
        localStorage.removeItem('booyaVerified');
      };

      $.ajax(_objectSpread(_objectSpread({
        url: self.getAPIEndpointURL('/auth/verify')
      }, token ? {
        type: "POST",
        data: 'token=' + token
      } : {
        type: "GET"
      }), {}, {
        dataType: 'json',
        xhrFields: {
          withCredentials: true
        }
      })).done(function (data) {
        if (data.user) {
          var parseComparableUrl = function parseComparableUrl(url) {
            return (url || '').replace(/^https?:\/\//i, '').replace(/\?.*$/i, '').replace(/#.*$/i, '');
          };

          window.user = data.user;

          if (data.token) {
            localStorage.setItem('booyaToken', data.token);
            self.setCookie('booyaToken', data.token);

            if (data.template_token) {
              self.setCookie('booyaTemplateToken', data.template_token);
            }

            if (code) {
              // Remove code from URL
              history.replaceState(null, "", location.pathname + self.getQueryStringWithoutAuthParams());

              if (token === code) {
                // User just logged in with OAuth
                self.trigger(self.events.OAUTH_LOGIN_SUCCESS);
              }
            }
          }

          var dedicatedMemberUrl = '';

          if (data && data.user && self.config && self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules)) {
            var _iterator6 = _createForOfIteratorHelper(self.config.advancedMemberUrlConfig.rules),
                _step6;

            try {
              for (_iterator6.s(); !(_step6 = _iterator6.n()).done;) {
                var rule = _step6.value;

                if (!dedicatedMemberUrl && rule.name && rule.value && rule.url && data.user[rule.name] === rule.value) {
                  dedicatedMemberUrl = rule.url;
                }
              }
            } catch (err) {
              _iterator6.e(err);
            } finally {
              _iterator6.f();
            }
          }

          if (!dedicatedMemberUrl && self.config.memberUrl) {
            dedicatedMemberUrl = self.config.memberUrl;
          }

          if (dedicatedMemberUrl) {
            var comparableCurrentLocation = parseComparableUrl(window.location.href),
                comparableRedirectableUrls = [self.config.guestUrl, self.config.memberUrl].concat(_toConsumableArray((self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules) ? self.config.advancedMemberUrlConfig.rules : []).map(function (i) {
              return i.url;
            }))).filter(function (i) {
              return i;
            }).map(function (i) {
              return parseComparableUrl(i);
            });

            if ((!self.config.guestUrl && /\/(login|signin)([\/?#]|$)/i.test(location.pathname) || comparableRedirectableUrls.includes(comparableCurrentLocation)) && parseComparableUrl(dedicatedMemberUrl) !== comparableCurrentLocation) {
              var memberRedirectUrl = "".concat(dedicatedMemberUrl).concat(location.search ? "".concat(/\?/i.test(dedicatedMemberUrl) ? '&' : '?').concat((location.search || '').replace('?', '')) : '');
              self.trigger(self.events.MEMBER_URL_REDIRECT, {
                user: data && data.user || null,
                nextUrl: memberRedirectUrl
              });

              if (!self.isEventOverridden(self.events.MEMBER_URL_REDIRECT)) {
                window.location.href = memberRedirectUrl;
                return;
              }
            }
          }

          var user = data.user;
          /* Identify User in HubSpot */

          if (user.email) {
            self.identifyHubSpotUser(user.email); // Set email in hubspot forms

            var setHubSpotFormEmails = function setHubSpotFormEmails() {
              var emailInputSelector = 'form.hs-form .hs-form-field.hs-email input.hs-input[type="email"]';
              $(emailInputSelector, $('.hbspt-form iframe.hs-form-iframe').contents()).val(user.email);
              $(emailInputSelector).val(user.email);
            };

            setHubSpotFormEmails();
            setTimeout(setHubSpotFormEmails, 200);
          }

          self.trigger(self.events.IDENTIFY_SUCCESS, {
            user: user
          }); // Prompt user for email verification

          if (user.email && user.not_verified && !self.getUrlParameter('verification_key')) {
            var initVerificationEmailSender = function initVerificationEmailSender() {
              $('.' + resendSelector).off('click').click(function (e) {
                e.preventDefault();
                var verificationBannerWrapper = $(this).closest('.__booya-banner');
                var verificationMessageWrapper = verificationBannerWrapper.find('.__booya-banner-message');
                verificationMessageWrapper.html('Sending ...');
                var payload = 'email=' + user.email + '&next_url=' + (self.getUrlParameter('next') || location.href);
                var lang = self.translations.resolvedLanguage();

                if (lang) {
                  payload = "".concat(payload, "&lang=").concat(lang);
                }

                $.ajax({
                  url: self.getAPIEndpointURL("/auth/resend-verification/"),
                  type: "POST",
                  data: payload,
                  dataType: 'json',
                  xhrFields: {
                    withCredentials: true
                  }
                }).done(function (data) {
                  verificationMessageWrapper.html(self.translations.getTranslation(self.translations.phrases.ACCOUNT_VERIFICATION_SENT, {
                    email: user.email
                  }));
                  verificationBannerWrapper.addClass('__booya-banner-success');
                  verificationBannerWrapper.removeClass('__booya-banner-danger');
                  setTimeout(function () {
                    verificationBannerWrapper.remove();
                  }, 5000);
                }).fail(function (error) {
                  verificationMessageWrapper.html('Failed to resend verification email to ' + user.email + '. Please <a href="#" class="' + resendSelector + '">try again</a>');
                  initVerificationEmailSender();
                });
              });
            };

            var resendSelector = '__booya-email--verification-resend';
            var verificationMessage = self.translations.getTranslation(self.translations.phrases.YOUR_EMAIL_NOT_VERIFIED_CHECK_INBOX, {
              email: user.email,
              link_open: '<a href="#" class="' + resendSelector + '">',
              link_close: "</a>"
            });
            self.widgets.renderBanner(verificationMessage, self.widgets.banners.DANGER, true);
            initVerificationEmailSender();
          }

          if (self.config && (typeof self.config.requireCompleteProfile != 'boolean' || self.config.requireCompleteProfile)) {
            // Prompt User to complete profile if necessary
            var requiredFields = self.config && self.config.forms && self.config.forms.profile && self.config.forms.profile.requiredFields || null;

            if (!Array.isArray(requiredFields) || !requiredFields.length) {
              requiredFields = ['first_name', 'last_name'];
            }

            var hasMissingRequiredFields = !!requiredFields.map(function (field) {
              return !user[field] && user[field] !== 0 && typeof user[field] !== 'boolean';
            }).filter(function (i) {
              return i === true;
            }).length;

            if (hasMissingRequiredFields) {
              self.trigger(self.events.COMPLETE_PROFILE_PROMPT);

              if (!self.isEventOverridden(self.events.COMPLETE_PROFILE_PROMPT)) {
                var formSelector = 'form.__booya-profile-form';
                var form = $(formSelector);

                if (form.length) {
                  form.replaceWith(self.widgets.renderProfileForm());
                  self.initUI();
                  form.closest(".".concat(self.widgets.selectors.modal)).show();
                } else {
                  self.widgets.renderModal('', self.widgets.renderProfileForm(), {
                    isOpen: true,
                    isTop: true
                  });
                }
              }
            }
          }
        } else if (magicLinkKey) {
          self.verifyMagicLink();
        }

        if (data.user || !magicLinkKey) {
          if (verificationKey) {
            self.verifyAccount();
          } else if (isVerified) {
            showAndClearVerified();
          }
        }
      }).fail(function (error) {
        if (verificationKey) {
          // Attempt to verify with verification_key
          self.verifyAccount();
        } else if (magicLinkKey) {
          // Attempt to verify with magic_link_key
          self.verifyMagicLink();
        } else {
          self.trigger(self.events.IDENTIFY_FAILED);

          if (isVerified) {
            showAndClearVerified();
          }
        }
      });
    }
  }, {
    key: "verifyAccount",
    value: function verifyAccount() {
      var self = this;
      var token = this.getUrlParameter('verification_key');

      if (token) {
        $.ajax({
          url: this.getAPIEndpointURL('/auth/verify/account'),
          type: "POST",
          data: 'token=' + token + (window.user ? '' : "&authenticate=true"),
          dataType: 'json',
          xhrFields: {
            withCredentials: true
          }
        }).done(function (data) {
          // Remove key from URL
          history.replaceState(null, "", location.pathname + self.getQueryStringWithoutAuthParams());

          if (data.token) {
            localStorage.setItem('booyaToken', data.token);
            self.setCookie('booyaToken', data.token);

            if (data.template_token) {
              self.setCookie('booyaTemplateToken', data.template_token);
            }
          } else if (!window.user) {
            self.trigger(self.events.IDENTIFY_FAILED);
          }

          if (window.user || !data.token) {
            // Show banner if no redirects are expected
            self.widgets.renderAccountVerifiedBanner();
          } else {
            // Otherwise wait for redirect/reload
            localStorage.setItem('booyaVerified', 'true');
          }

          self.trigger(self.events.VERIFY_ACCOUNT_SUCCESS);

          if (!self.isEventOverridden(self.events.VERIFY_ACCOUNT_SUCCESS) && !window.user && data.token) {
            // Reload to pick up new session
            location.reload();
          }
        }).fail(function (error) {
          self.trigger(self.events.VERIFY_ACCOUNT_FAILED);

          if (!window.user) {
            self.trigger(self.events.IDENTIFY_FAILED);
          }
        });
      }
    }
  }, {
    key: "verifyMagicLink",
    value: function verifyMagicLink() {
      var self = this;
      var token = this.getUrlParameter('magic_link_key');

      if (token) {
        $.ajax({
          url: this.getAPIEndpointURL('/auth/magic-link/verify'),
          type: "POST",
          data: 'token=' + token,
          dataType: 'json',
          xhrFields: {
            withCredentials: true
          }
        }).done(function (data) {
          // Remove key from URL
          history.replaceState(null, "", location.pathname + self.getQueryStringWithoutAuthParams());

          if (data.token) {
            localStorage.setItem('booyaToken', data.token);
            self.setCookie('booyaToken', data.token);

            if (data.template_token) {
              self.setCookie('booyaTemplateToken', data.template_token);
            }
          } else if (!window.user) {
            self.trigger(self.events.IDENTIFY_FAILED);
          }

          self.trigger(self.events.MAGIC_LINK_VERIFY_SUCCESS);

          if (!self.isEventOverridden(self.events.MAGIC_LINK_VERIFY_SUCCESS) && !window.user && data.token) {
            var memberRedirectUrl = '';

            if (data && data.user && self.config && self.config.advancedMemberUrlConfig && self.config.advancedMemberUrlConfig.enabled && Array.isArray(self.config.advancedMemberUrlConfig.rules)) {
              var _iterator7 = _createForOfIteratorHelper(self.config.advancedMemberUrlConfig.rules),
                  _step7;

              try {
                for (_iterator7.s(); !(_step7 = _iterator7.n()).done;) {
                  var rule = _step7.value;

                  if (!memberRedirectUrl && rule.name && rule.value && rule.url && data.user[rule.name] === rule.value) {
                    memberRedirectUrl = rule.url;
                  }
                }
              } catch (err) {
                _iterator7.e(err);
              } finally {
                _iterator7.f();
              }
            }

            var nextUrl = self.getUrlParameter('next');

            if (memberRedirectUrl) {
              self.trigger(self.events.MEMBER_URL_REDIRECT, {
                user: data && data.user || null,
                nextUrl: memberRedirectUrl
              });

              if (!self.isEventOverridden(self.events.MEMBER_URL_REDIRECT)) {
                location.href = memberRedirectUrl;
              }
            } else if (nextUrl) {
              location.href = nextUrl;
            } else if (self.config.memberUrl) {
              location.href = self.config.memberUrl;
            } else {
              // Reload to pick up new session
              location.reload();
            }
          }
        }).fail(function (error) {
          self.trigger(self.events.MAGIC_LINK_VERIFY_FAILED);

          if (!window.user) {
            self.trigger(self.events.IDENTIFY_FAILED);
          }

          var reason = error && error.responseJSON && error.responseJSON.reason;

          var _split = (token || '').split(':'),
              _split2 = _slicedToArray(_split, 2),
              userId = _split2[0],
              otp = _split2[1];

          if (userId && reason && ['expired', 'invalid_or_expired'].includes(reason)) {
            var resendButtonSelector = '__booya-magic-link-resend--button',
                resendStatusSelector = '__booya-magic-link-resend--status',
                resendContainerSelector = '__booya-magic-link-resend--container';
            self.widgets.renderModal('', "\n<div class=\"".concat(resendContainerSelector, "\" style=\"text-align: center; margin-top: -30px;\">\n    <div class=\"").concat(resendStatusSelector, "\">\n    ").concat(self.widgets.renderNotice(self.translations.getTranslation(self.translations.phrases.THIS_MAGIC_LINK_INVALID_EXPIRED), self.widgets.notices.DANGER), "\n    </div>\n    <button class=\"__booya-btn ").concat(resendButtonSelector, "\">\n        ").concat(self.translations.getTranslation(self.translations.phrases.REQUEST_NEW_MAGIC_LINK), "\n    </button>\n</div>\n                        "), {
              isOpen: true,
              isTop: true
            });
            var resendButtonElement = $(".".concat(resendButtonSelector)),
                resendStatusElement = $(".".concat(resendStatusSelector));
            resendButtonElement.off('click').click(function (e) {
              e.preventDefault();
              var nextUrl = (self.getUrlParameter('next') || location.href || '').replace("magic_link_key=".concat(encodeURIComponent(token)), '');
              var payload = 'userId=' + encodeURIComponent(userId) + '&next_url=' + encodeURIComponent(nextUrl);
              var lang = self.translations.resolvedLanguage();

              if (lang) {
                payload = "".concat(payload, "&lang=").concat(lang);
              }

              resendStatusElement.html(self.widgets.renderNotice(self.translations.getTranslation(self.translations.phrases.RESENDING_MAGIC_LINK), self.widgets.notices.INFO));
              resendButtonElement.prop('disabled', true);
              $.ajax({
                url: self.getAPIEndpointURL("/auth/magic-link/request"),
                type: "POST",
                data: payload,
                dataType: 'json',
                xhrFields: {
                  withCredentials: true
                }
              }).done(function (data) {
                resendStatusElement.html(self.widgets.renderNotice(self.translations.getTranslation(self.translations.phrases.PLEASE_CHECK_INBOX_INSTRUCTIONS), self.widgets.notices.SUCCESS));
                resendButtonElement.prop('disabled', true);
                self.trigger(self.events.MAGIC_LINK_REQUEST_SUCCESS, {});
              }).fail(function (error) {
                resendStatusElement.html(self.widgets.renderNotice(self.translations.getTranslation(self.translations.phrases.OOPS_RESEND_MAGIC_LINK), self.widgets.notices.DANGER));
                resendButtonElement.prop('disabled', false);
                self.trigger(self.events.MAGIC_LINK_REQUEST_FAILED, {});
              });
            });
          } else {
            self.widgets.renderBanner('This magic link is invalid.', self.widgets.banners.DANGER);
          }
        });
      }
    }
  }, {
    key: "initSetPassword",
    value: function initSetPassword() {
      var token = this.getUrlParameter('invitation_key');

      if (token) {
        window.invitationToken = token;
        var formSelector = 'form.__booya-reset-password-form';
        var form = $(formSelector);

        if (!form.length) {
          // Redirect to reset form
          var inviteAcceptUrl = this.config && this.config.invite && this.config.invite.acceptUrl || '';

          if (inviteAcceptUrl && location.href.search(inviteAcceptUrl) === -1) {
            location.href = "".concat(inviteAcceptUrl, "?invitation_key=").concat(token);
            return;
          }

          $('body').append(this.widgets.renderModal('', this.widgets.renderSetPasswordForm(), {
            isOpen: true,
            isTop: true
          }));
          this.initUI();
          form = $(formSelector);
        }
      }
    }
  }, {
    key: "initResetPassword",
    value: function initResetPassword() {
      var token = this.getUrlParameter('recovery_key');

      if (token) {
        window.recoveryToken = token;
        var formSelector = 'form.__booya-reset-password-form';
        var form = $(formSelector);

        if (!form.length) {
          // Redirect to reset form
          if (this.config.resetUrl && location.href.search(this.config.resetUrl) === -1) {
            location.href = "".concat(this.config.resetUrl, "?recovery_key=").concat(token);
            return;
          }

          $('body').append(this.widgets.renderModal('', this.widgets.renderResetForm(), {
            isOpen: true,
            isTop: true
          }));
          this.initUI();
          form = $(formSelector);
        }
      }
    }
  }, {
    key: "processHubSpotProfileData",
    value: function processHubSpotProfileData(rawData) {
      var PROFILE_FIELD_MAP = {
        first_name: 'firstname',
        last_name: 'lastname',
        telephone: 'phone'
      };
      var data = [];
      $.each(rawData, function (idx, item) {
        if (item.value && !/password|LEGAL_CONSENT/i.test(item.name)) {
          data.push({
            name: PROFILE_FIELD_MAP[item.name] || item.name,
            value: item.value
          });
        }
      });
      return data;
    }
  }, {
    key: "processProfileData",
    value: function processProfileData(rawData) {
      var data = {};
      $.each(rawData, function (idx, item) {
        if (item.value && !/password|LEGAL_CONSENT/i.test(item.name)) {
          data[item.name] = item.value;
        }
      });
      return data;
    }
  }, {
    key: "init",
    value: function init(config) {
      this.setConfig(config); // Don't initialize if integration is not setup yet

      if (!this.config.__setup) return;

      if (Array.isArray(window.booyaQueue) && window.booyaQueue.length) {
        var _iterator8 = _createForOfIteratorHelper(window.booyaQueue),
            _step8;

        try {
          for (_iterator8.s(); !(_step8 = _iterator8.n()).done;) {
            var readyCallback = _step8.value;

            if (readyCallback && typeof readyCallback === 'function') {
              this.ready(readyCallback);
            }
          }
        } catch (err) {
          _iterator8.e(err);
        } finally {
          _iterator8.f();
        }

        window.booyaQueue = [];
      } // Init auth components


      if (!this.isInitialized) {
        this.verifyUser();
        this.initSetPassword();
        this.initResetPassword();
        this.isInitialized = true;
      }

      this.initUI();
    }
  }, {
    key: "on",
    value: function on(event, callback) {
      if (typeof callback === 'function') {
        $(document).on(event, function (e) {
          try {
            callback(e);
          } catch (e) {
            console.error("booya: ".concat(event, " callback error =>"), e);
          }
        });

        if (!this.state.events || !Array.isArray(this.state.events)) {
          this.state.events = [];
        }

        if (!this.state.events.includes(event)) {
          this.state.events.push(event);
        }
      }
    }
  }, {
    key: "ready",
    value: function ready(callback) {
      if (typeof callback === 'function') {
        if (this.isReady) {
          // trigger immediately if app is ready
          try {
            callback();
          } catch (e) {
            console.error("booya: ".concat(this.events.READY, " callback error"), e);
          }
        }

        this.on(this.events.READY, callback);
      }
    }
  }, {
    key: "add",
    value: function add(options) {
      var self = this,
          _ref31 = options || {},
          type = _ref31.type,
          widgetName = _ref31.name,
          target = _ref31.target,
          widgetConfig = _ref31.config;

      if (type === 'widget') {
        var _DASHBOARD_TITLE_MAP, _DASHBOARD_NAME_MAP;

        var settings = widgetConfig.settings,
            theme = widgetConfig.theme;
        var WIDGET_TYPES = {
          BLOG_POST: 'blog_post',
          COMPANY: 'company',
          CONTACT: 'contact',
          DEAL: 'deal',
          HUBDB: 'hubdb',
          LOCK: 'lock',
          MARKETING_EVENT: 'marketing_event',
          PRODUCT: 'product',
          QUOTE: 'quote',
          TICKET: 'ticket'
        },
            DASHBOARD_TITLE_MAP = (_DASHBOARD_TITLE_MAP = {}, _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.BLOG_POST, 'Blog Posts'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.COMPANY, 'Company'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.CONTACT, 'Contact Information'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.DEAL, 'Projects'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.HUBDB, 'Table'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.MARKETING_EVENT, 'Events'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.PRODUCT, 'Products'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.QUOTE, 'Quotes'), _defineProperty(_DASHBOARD_TITLE_MAP, WIDGET_TYPES.TICKET, 'Tickets'), _DASHBOARD_TITLE_MAP),
            DASHBOARD_NAME_MAP = (_DASHBOARD_NAME_MAP = {}, _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.BLOG_POST, 'blog post'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.COMPANY, 'company'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.CONTACT, 'contact'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.DEAL, 'project'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.HUBDB, 'table'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.MARKETING_EVENT, 'event'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.PRODUCT, 'product'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.QUOTE, 'quote'), _defineProperty(_DASHBOARD_NAME_MAP, WIDGET_TYPES.TICKET, 'ticket'), _DASHBOARD_NAME_MAP);

        var removeDnDVerticalAligner = function removeDnDVerticalAligner(wrapper) {
          var dndModuleId = wrapper.attr('data-hs-widget-id');

          if (dndModuleId) {
            wrapper.closest('.dnd-module').removeClass("".concat(dndModuleId, "-vertical-alignment"));
          }

          wrapper.closest('.dnd-section').addClass('__booya-brix-dashboard-section');
        };

        var pluralize = function pluralize(word) {
          var regex = /y$/i;
          return regex.test(word) ? "".concat(word.replace(regex, 'ies')) : "".concat(word, "s");
        };

        switch (widgetName) {
          case WIDGET_TYPES.LOCK:
            {
              var _ref32 = theme || {},
                  anchor_font_color = _ref32.anchor_font_color,
                  button_bg_color = _ref32.button_bg_color,
                  button_font_color = _ref32.button_font_color,
                  form_input_focus_border_color = _ref32.form_input_focus_border_color;

              if (self.config.__product === 'brix') {
                $('head').append("\n                        <style>\n                        .__booya-link {\n                          color: ".concat(anchor_font_color, " !important;\n                        }\n                        \n                        .__booya-link:hover,\n                        .__booya-link:focus {\n                          color: ").concat(anchor_font_color, " !important;\n                        }\n                        \n                        .__booya-link:active {\n                          color: ").concat(anchor_font_color, " !important;\n                        }\n                        \n                        .__booya-btn,\n                        .__booya-btn:link,\n                        .__booya-btn:visited {\n                          color: ").concat(button_font_color, ";\n                          background-color: ").concat(button_bg_color, ";\n                        }\n                        \n                        .__booya-btn:hover,\n                        .__booya-btn:focus {\n                          color: ").concat(button_font_color, ";\n                          background-color: ").concat(button_bg_color, ";\n                        }\n                        \n                        form.__booya-form input:focus,\n                        form.__booya-form input.focus,\n                        form.__booya-form textarea:focus,\n                        form.__booya-form textarea.focus,\n                        form.__booya-form select:focus,\n                        form.__booya-form select.focus {\n                          border-color: ").concat(form_input_focus_border_color, " !important;\n                          box-shadow: none !important;\n                        }\n                        \n                        .__booya-user-widget > div > img,\n                        .__booya-user-widget > img {\n                          vertical-align: inherit;\n                        }\n                        </style>\n                        "));
              }

              var _ref33 = settings || {},
                  open_as_modal = _ref33.open_as_modal,
                  multi_step = _ref33.multi_step,
                  default_form = _ref33.default_form,
                  enabled_forms = _ref33.enabled_forms;

              var authOptions = _objectSpread(_objectSpread({
                target: target || null
              }, open_as_modal ? {
                modal: {
                  isOpen: true
                }
              } : {}), {}, {
                section: default_form
              });

              var signin = enabled_forms.signin,
                  signup = enabled_forms.signup,
                  recover = enabled_forms.recover,
                  magic_link = enabled_forms.magic_link;

              for (var _i7 = 0, _arr6 = [['multiStep', multi_step], ['signIn', signin], ['signUn', signup], ['recover', recover], ['magicLink', magic_link]]; _i7 < _arr6.length; _i7++) {
                var _arr6$_i = _slicedToArray(_arr6[_i7], 2),
                    dest = _arr6$_i[0],
                    source = _arr6$_i[1];

                if (typeof source === 'boolean') {
                  authOptions[dest] = source;
                }
              }

              self.widgets.renderAuthWidgets(authOptions);
              break;
            }

          case WIDGET_TYPES.BLOG_POST:
          case WIDGET_TYPES.COMPANY:
          case WIDGET_TYPES.CONTACT:
          case WIDGET_TYPES.DEAL:
          case WIDGET_TYPES.HUBDB:
          case WIDGET_TYPES.PRODUCT:
          case WIDGET_TYPES.QUOTE:
          case WIDGET_TYPES.TICKET:
            {
              var _ref34 = settings || {},
                  title = _ref34.title,
                  properties = _ref34.properties,
                  table = _ref34.table,
                  email_field = _ref34.email_field,
                  fields = _ref34.fields;

              var _ref35 = theme || {},
                  _button_bg_color = _ref35.button_bg_color,
                  _button_font_color = _ref35.button_font_color,
                  table_head_bg_color = _ref35.table_head_bg_color,
                  table_border_color = _ref35.table_border_color,
                  table_head_font_color = _ref35.table_head_font_color;

              if (self.config.__product === 'brix') {
                $('head').append("\n                        <style>\n                        .__booya-brix-badge {\n                            ".concat(_button_font_color ? "color: ".concat(_button_font_color) : '', ";\n                            ").concat(_button_bg_color ? "background-color: ".concat(_button_bg_color) : '', ";\n                        }\n                        .__booya-brix-table thead th {\n                            ").concat(table_head_bg_color ? "background-color: ".concat(table_head_bg_color) : '', ";\n                            ").concat(table_border_color ? "border-bottom-color: ".concat(_button_bg_color) : '', ";\n                            ").concat(table_head_font_color ? "color: ".concat(table_head_font_color) : '', ";\n                        }\n                        .__booya-brix-table.__booya-brix-table-vertical th > * {\n                            ").concat(table_head_font_color ? "color: ".concat(table_head_font_color) : '', ";\n                        }\n                        .__booya-brix-dashboard-section .dnd-column {\n                            padding: 0;\n                            justify-content: flex-start !important;\n                        }\n                        </style>\n                        "));
              }

              var widgetWrapper = $(target);
              widgetWrapper.html(self.translations.getTranslation(self.translations.phrases.LOADING));
              var isContactOrCompany = [WIDGET_TYPES.CONTACT, WIDGET_TYPES.COMPANY].includes(widgetName) ? '__booya-brix-table-vertical' : '';

              var renderDashboardWidget = function renderDashboardWidget(response, error) {
                var dashboardWidgetBody = '',
                    numObjects = 0;

                var getDynamicProperties = function getDynamicProperties() {
                  if (response && Array.isArray(response.order) && response.order.length) {
                    return response.order;
                  }

                  var properties = response && (response.properties || response.fields) || null;

                  if (properties && _typeof(properties) === 'object' && Object.keys(properties).length) {
                    return Object.keys(properties);
                  }

                  switch (widgetName) {
                    case WIDGET_TYPES.COMPANY:
                      {
                        return ['name', 'domain'];
                      }

                    case WIDGET_TYPES.CONTACT:
                      {
                        return ['email', 'firstname', 'lastname'];
                      }

                    default:
                      {
                        return ['id', 'name'];
                      }
                  }
                };

                var getDynamicPropertyLabel = function getDynamicPropertyLabel(name) {
                  var properties = response && (response.properties || response.fields) || null;
                  return properties && properties[name] || name;
                };

                var getDynamicPropertyDisplayValue = function getDynamicPropertyDisplayValue(value, name) {
                  var options = response && response.options || null;

                  if (options && options[name] && options[name][value]) {
                    value = options[name] && options[name][value];
                  }

                  if (Array.isArray(value)) {
                    return value.map(function (subValue) {
                      return getDynamicPropertyDisplayValue(subValue, name);
                    }).join(', ');
                  } else if (value && _typeof(value) === 'object') {
                    var firstKey = Object.keys(value)[0] || '';
                    return value.name || value.label || value.id || value[firstKey] || '';
                  }

                  return value || '';
                };

                var getHeaderColumns = function getHeaderColumns() {
                  var columns = [];

                  switch (widgetName) {
                    case WIDGET_TYPES.BLOG_POST:
                      {
                        columns = ['Title', 'Description', 'Author', 'Published', 'Tags'];
                        break;
                      }

                    case WIDGET_TYPES.COMPANY:
                    case WIDGET_TYPES.CONTACT:
                      {
                        columns = [];
                        break;
                      }

                    case WIDGET_TYPES.DEAL:
                      {
                        columns = ['Name', 'Amount', 'Stage', 'Pipeline', 'Closed'];
                        break;
                      }

                    case WIDGET_TYPES.HUBDB:
                      {
                        columns = getDynamicProperties().map(function (name) {
                          return getDynamicPropertyLabel(name);
                        });
                        break;
                      }

                    case WIDGET_TYPES.PRODUCT:
                      {
                        columns = ['Name', 'Price', 'SKU', 'Updated'];
                        break;
                      }

                    case WIDGET_TYPES.QUOTE:
                      {
                        columns = ['Number', 'Title', 'Amount', 'Status', 'Expires'];
                        break;
                      }

                    case WIDGET_TYPES.TICKET:
                      {
                        columns = ['Ticket ID', 'Subject', 'Priority', 'Stage', 'Updated'];
                        break;
                      }

                    default:
                      break;
                  }

                  return columns;
                };

                var renderDashboardHeader = function renderDashboardHeader() {
                  if (isContactOrCompany) {
                    return '';
                  }

                  return "\n                                <thead>\n                                    ".concat(getHeaderColumns().map(function (field) {
                    return "<th>".concat(field, "</th>");
                  }).join(''), "\n                                </thead>\n                            ");
                };

                var renderDashboardWidgetRow = function renderDashboardWidgetRow(object) {
                  switch (widgetName) {
                    case WIDGET_TYPES.BLOG_POST:
                      {
                        return "\n                                        <tr>\n                                            <td><a href=\"".concat(object.properties.url, "\" target=\"_blank\">").concat(object.properties.title, "</a></td>\n                                            <td>").concat(object.properties.description, "</td>\n                                            <td>").concat(object.properties.author, "</td>\n                                            <td>").concat(object.properties.date ? new Date(object.properties.date).toLocaleDateString() : '', "</td>\n                                            <td>").concat((object.properties.tags || []).join(', '), "</td>\n                                        </tr>\n                                    ");
                      }

                    case WIDGET_TYPES.COMPANY:
                    case WIDGET_TYPES.CONTACT:
                      {
                        return getDynamicProperties().map(function (name) {
                          return "\n                                            <tr>\n                                                <th>".concat(getDynamicPropertyLabel(name), "</th><td>").concat(getDynamicPropertyDisplayValue(object.properties[name], name) || '', "</td>\n                                            </tr>\n                                        ");
                        }).join('\n');
                      }

                    case WIDGET_TYPES.DEAL:
                      {
                        var closeDate = object.properties.closedate;
                        return "\n                                        <tr>\n                                            <td>".concat(object.properties.dealname, "</td>\n                                            <td>$").concat(object.properties.amount, "</td>\n                                            <td>").concat(object.properties.dealstage_label || object.properties.dealstage, "</td>\n                                            <td>").concat(object.properties.pipeline_label || object.properties.pipeline, "</td>\n                                            <td>").concat(closeDate ? new Date(closeDate).toLocaleDateString() : '', "</td>\n                                        </tr>\n                                    ");
                      }

                    case WIDGET_TYPES.HUBDB:
                      {
                        return "\n                                        <tr>\n                                            ".concat(getDynamicProperties().map(function (name) {
                          return "<td>".concat(getDynamicPropertyDisplayValue(object.properties[name], name) || '', "</td>");
                        }).join('\n'), "\n                                        </tr>\n                                    ");
                      }

                    case WIDGET_TYPES.PRODUCT:
                      {
                        return "\n                                        <tr>\n                                            <td>".concat(object.properties.name, "</td>\n                                            <td>$").concat(object.properties.price, "</td>\n                                            <td>").concat(object.properties.hs_sku, "</td>\n                                            <td>").concat(new Date(object.properties.hs_lastmodifieddate || object.properties.createdate).toLocaleDateString(), "</td>\n                                        </tr>\n                                    ");
                      }

                    case WIDGET_TYPES.QUOTE:
                      {
                        var expiresDate = object.properties.hs_expiration_date;
                        return "\n                                        <tr>\n                                            <td>".concat(object.properties.hs_quote_number, "</td>\n                                            <td>").concat(object.properties.hs_title, "</td>\n                                            <td>$").concat(object.properties.hs_quote_amount, "</td>\n                                            <td>").concat(object.properties.hs_status || object.properties.hs_status, "</td>\n                                            <td>").concat(expiresDate ? new Date(expiresDate).toLocaleDateString() : '', "</td>\n                                        </tr>\n                                    ");
                      }

                    case WIDGET_TYPES.TICKET:
                      {
                        var ticketPriority = object.properties.hs_ticket_priority || '';
                        return "\n                                        <tr>\n                                            <td>".concat(object.id, "</td>\n                                            <td>").concat(object.properties.subject, "</td>\n                                            <td><span class=\"__booya-brix-ticket-priority __booya-brix-ticket-priority-").concat(ticketPriority.toLowerCase(), "\">").concat(ticketPriority.substr(0, 1)).concat(ticketPriority.substr(1).toLowerCase(), "</span></td>\n                                            <td>").concat(object.properties.hs_pipeline_stage_label || object.properties.hs_pipeline_stage, "</td>\n                                            <td>").concat(new Date(object.properties.hs_lastmodifieddate || object.properties.createdate).toLocaleDateString(), "</td>\n                                        </tr>\n                                    ");
                      }

                    default:
                      {
                        return '';
                      }
                  }
                };

                var renderDashboardWidgetStatus = function renderDashboardWidgetStatus(message) {
                  var colspan = getHeaderColumns().length;
                  return "<tr>\n                                        <td colspan=\"".concat(colspan, "\">\n                                            ").concat(message || "No ".concat(pluralize(widgetName === WIDGET_TYPES.HUBDB ? 'entry' : DASHBOARD_NAME_MAP[widgetName]), " found."), "\n                                        </td>\n                                    </tr>");
                };

                if (response && response.results) {
                  numObjects = (response.results || []).length;
                  var cleanResults = response.results || [];

                  if (isContactOrCompany) {
                    // Limit to one result
                    cleanResults = cleanResults.slice(0, 1);
                  }

                  var _iterator9 = _createForOfIteratorHelper(cleanResults),
                      _step9;

                  try {
                    for (_iterator9.s(); !(_step9 = _iterator9.n()).done;) {
                      var object = _step9.value;
                      dashboardWidgetBody += renderDashboardWidgetRow(object);
                    }
                  } catch (err) {
                    _iterator9.e(err);
                  } finally {
                    _iterator9.f();
                  }

                  if (!dashboardWidgetBody) {
                    dashboardWidgetBody = renderDashboardWidgetStatus();
                  }
                }

                if (!dashboardWidgetBody) {
                  switch (error) {
                    case 'no_permission':
                      {
                        dashboardWidgetBody = renderDashboardWidgetStatus("".concat(DASHBOARD_TITLE_MAP[widgetName], " are not set up for your account. Please contact support."));
                        break;
                      }

                    default:
                      {
                        dashboardWidgetBody = renderDashboardWidgetStatus("Oops! We failed to load your ".concat(pluralize(DASHBOARD_NAME_MAP[widgetName]), ". Please contact support if this issue persists."));
                        break;
                      }
                  }
                }

                dashboardWidgetBody = "\n                            <table class=\"__booya-brix-table ".concat([WIDGET_TYPES.COMPANY, WIDGET_TYPES.CONTACT].includes(widgetName) ? '__booya-brix-table-vertical' : '', "\">\n                            ").concat(renderDashboardHeader(), "\n                            <tbody>\n                            ").concat(dashboardWidgetBody, "\n                            </tbody>\n                            </table>\n                        ");
                widgetWrapper.html("\n                            <h3>".concat(title || DASHBOARD_TITLE_MAP[widgetName]).concat(numObjects && !isContactOrCompany ? " <span class=\"__booya-brix-badge\">".concat(numObjects, "</span>") : '', "</h3>\n                            ").concat(dashboardWidgetBody, "\n                        "));
                removeDnDVerticalAligner(widgetWrapper);
              };

              var qParams = ["vid=".concat(window.user && window.user.vid || ''), "email=".concat(window.user && window.user.email || '')];

              for (var _i8 = 0, _arr7 = [['email_field', email_field], ['table', table], ['properties', properties], ['fields', fields]]; _i8 < _arr7.length; _i8++) {
                var _arr7$_i = _slicedToArray(_arr7[_i8], 2),
                    key = _arr7$_i[0],
                    value = _arr7$_i[1];

                if (Array.isArray(value)) {
                  if (value.length) {
                    qParams.push("".concat(key, "=").concat(value.join(',')));
                  }
                } else if (value) {
                  qParams.push("".concat(key, "=").concat(value));
                }
              }

              $.ajax({
                url: "".concat(self.getAPIEndpointURL("/api/hubspot/objects/".concat(widgetName === WIDGET_TYPES.CONTACT ? 'my_contact' : widgetName === WIDGET_TYPES.HUBDB ? WIDGET_TYPES.HUBDB : pluralize(widgetName))), "?").concat(qParams.join('&')),
                type: "GET",
                dataType: 'json',
                xhrFields: {
                  withCredentials: true
                }
              }).done(function (data) {
                renderDashboardWidget(data, null);
              }).fail(function (error) {
                if (error && error.responseText) {
                  try {
                    var data = $.parseJSON(error.responseText);
                    return renderDashboardWidget(null, data && data.reason || 'unknown');
                  } catch (e) {//
                  }
                }

                renderDashboardWidget(null, 'unknown');
              });
              break;
            }

          case WIDGET_TYPES.MARKETING_EVENT:
            {
              var _ref36 = settings || {},
                  _title = _ref36.title;

              var _widgetWrapper = $(target);

              _widgetWrapper.html("\n                        <h3>".concat(_title || DASHBOARD_TITLE_MAP[widgetName], "</h3>\n                        <table class=\"__booya-brix-table\">\n                        <tbody>\n                        <tr><td>Coming soon! Your ").concat(pluralize(DASHBOARD_NAME_MAP[widgetName] || '').toLowerCase(), " will appear here.</td></tr>\n                        </tbody>\n                        </table>\n                    "));

              removeDnDVerticalAligner(_widgetWrapper);
              break;
            }

          default:
            break;
        }
      }
    }
  }, {
    key: "createHSChatToken",
    value: function createHSChatToken(callback) {
      if (window.user && window.user.email) {
        var user = window.user;
        $.ajax({
          url: this.getAPIEndpointURL('/auth/hubspot/conversations/token'),
          type: "POST",
          data: JSON.stringify({
            email: user.email || '',
            firstname: user.firstname || '',
            lastname: user.lastname || ''
          }),
          contentType: 'application/json',
          processData: false,
          dataType: 'json',
          xhrFields: {
            withCredentials: true
          }
        }).done(function (data) {
          callback(data && data.token || null);
        }).fail(function (error) {
          callback(null);
        });
      } else {
        callback(null);
      }
    }
  }]);

  return Booya;
}();

window.booya = new Booya();
//# sourceMappingURL=booya.js.map